//==================================
// SIDaster Beta 1
// 25/09/2011
// http://bit.ly/fullmaj
// distributed under the ZLIB licensing policy : http://www.opensource.org/licenses/zlib-license.php
//==================================

//  Encoders v0.9
//  (FA) 16/04/2013
//  lecture encodeur
//  affichage sur LCD I2C
//  sauvegarde presets sur EEPROM 24LC256 I2C
//  Test fonction LFO...
//  ajout OPTIGATE en define (ON et OFF) 
//  voir plus bas, surtout OPTIGATEON interessant pour diminuer 
//  le bruit d'ouverture des VCA (enfin s'il y en a :) ) 




// May de SID be with You

#include <SID.h>
#include <MIDI.h>
#include "SIDasterIII.h"



// Include pour ecran LCD
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#if defined(ARDUINO) && ARDUINO >= 100
#define printByte(args)  write(args);
#else
#define printByte(args)  print(args,BYTE);
#endif
// Routine affichage de la RAM libre
#include <MemoryFree.h>  


//#define OPTIGATEOFF   // Si defini, ne ferme que les gates ouvert
#define OPTIGATEON    // Si defini, ouvre gate si forme onde !=0
//#define OPTIFREQ      // Optimisation maj reg freq sur SID
                        // ne fait la maj que si la freq a variee



#define PINBNAV A3      // Pin A3 (chaine des interrupteurs des encodeurs)
#define LCDSDA  A4      // Pin A4 :  Sortie SDA LCD
#define LCDSCL  A5      // Pin A5 :  Sortie SCL LCD  
#define B_F1    1       // Touche fonction 1 (OSC1 ou  LOAD)
#define B_F2    2       // Touche fonction 2 (OSC2 ou SAVE)
#define B_F3    3       // Touche fonction 3 (OSC3 ou EDIT-NAME)
#define B_F4    4       // Touche fonction 4 (Filter)
#define B_F5    5       // Touche fonction 5 (Mode : Edit SID ou Presets)
#define B_MAINT 9       // Derniere touche maintenue appuyee
#define LCDON      1    // 
#define LCDOFF     0    //
#define EDITSID 0       // Mode edition SID
#define EDITPRESETS 1   // Mode edition Name PRESET
#define MENUOSC1    0   // Menu oscillateur 1
#define MENUOSC2    1   // Menu oscillateur 2
#define MENUOSC3    2   // Menu oscillateur 3
#define MENUFILTER  3   // Menu filtre
#define MENUPRESETS 5   // Menu gestion des presets
#define MENULFO     6   // Menu gestion des lfo

#define ENC1DOWN  1     // Encodeur 1 down
#define ENC2DOWN  2     // Encodeur 2 down
#define ENC3DOWN  3     // Encodeur 3 down
#define ENC4DOWN  4     // Encodeur 4 down
#define ENC1UP    11    // Encodeur 1 up
#define ENC2UP    12    // Encodeur 2 up
#define ENC3UP    13    // Encodeur 3 up
#define ENC4UP    14    // Encodeur 4 up
#define ENCSTABLE 0     // Les encodeurs n'ont pas bouge
#define MAXPROG 128     // Programme max par banque
#define MAXBANK 4       // Nombre de banque
#define PRESETSIZE  64  // Taille dun preset
#define BANKSIZE  8192  // Taille dune banque (MAXPROG*PRESIZE)

#define CAR_RIGHT 126   // Numero car fleche vers la droite 
#define CAR_LEFT  127   // Numero car fleche vers la gauche
#define CAR_UP    0     // Numero car fleche vers le haut
#define CAR_DOWN  1     // Numero car fleche vers le bas
#define CAR_SEP   124   // Trait vertical de séparation
#define DELAYLFOS 500   // delay en µS entre chaque pas des LFO

//----------------------------------------------
// Declarations pour ajout programme F. ABIGNOLI
//----------------------------------------------
byte lastBoutonNav;                     // Stockage du dernier etat dun bouton
byte xm=0;                              // Position x dans la chaine de menu
byte ym=0;                              // Position y dans la chaine de menu
byte lxm=0;                             // last position x menu
byte lym=0;                             // last position y menu
byte modeMenu=0;                        // edition SID (0) ou preset (1)
byte valbouton;                         // Numero du bouton appuye
byte valencodeurs;                      // numero encodeur et sens
byte rafLCD;                            // Flag rafraichissement LCD
LiquidCrystal_I2C lcd(0x27,20,4);       // sLCD adress 0x27, 16 car, 2 lignes
uint8_t symbup[8]  = {0x4,0xe,0xf5,0x4,0x4,0x4,0x4};    //car LCD fleche up
uint8_t symbdown[8]  = {0x4,0x4,0x4,0x4,0xf5,0xe,0x4};  //car LCD fleche down
unsigned int tcnt2;                     // Valeur timer 2 pour reload dans ISR
int pinA[] = {2,4,6,15};                // Pins A des encodeurs
int pinB[] = {3,5,14,16};               // Pins B des encodeurs
int lcounter[] = {0,0,0,0};             // valeurs précédentes des encodeurs
volatile int lastEncoded[] = {0,0,0,0}; // Dernieres valeur lue encodeurs
volatile int counter[] = {0,0,0,0};     // Valeur courante des encodeurs
int bcounter[] = {0,0,0,0};             // valeurs encodeurs divisees par 4
byte myByte1,myByte2;                   // Variable de travail
word myWord1,myWord2;                   // Variable de travail
int myInt;                              // Variable de travail
char BuffAff[32];                       // Buffer pour transferer depuis flash
boolean RPAGE = false;                  // Flag rafraichissement menu
byte noPreset=0;                        // Numero du preset courant
byte noBanque=0;                        // Numero de banque courante
char nomPreset[18];                     // Nom du preset courant
byte posCarPreset=2;                    // Position x edition nom preset
byte Lfo1Speed = 0x01;           // Vitesse LFO 1
byte Lfo2Speed = 0x01;           // Vitesse LFO 2
byte Lfo1Wave = 0x01;            // Forme onde LFO 1
byte Lfo2Wave = 0x01;            // Forme onde LFO 2
byte Lfo1Dest = 0x00;            // Destination LFO 1
byte Lfo2Dest = 0x00;            // Destination LFO 2
byte Lfo1Val = 0x00;             // Valeur instantanee de LFO 1
byte Lfo2Val = 0x00;             // Valeur instantanee de LFO 2
byte LastLfo1Val = 0x00;         // Valeur precedente LFO 1
byte LastLfo2Val = 0x00;         // Valeur precedente LFO 2
byte Lfo1Level = 0x80;             // Valeur instantanee de LFO 1
byte Lfo2Level = 0x80;             // Valeur instantanee de LFO 2
byte Lfo1Pos = 0x00;           // Position LFO 1
byte Lfo2Pos = 0x00;           // Position LFO 2
byte Lfo1Prescaler = 0x20;     // Prescaler LFO 1
byte Lfo2Prescaler = 0x20;     // Prescaler LFO 2
byte Lfo1Counter = 0x00;       // Prescaler LFO 1
byte Lfo2Counter = 0x00;       // Prescaler LFO 2
byte lfofine1=0;                        // decalage freq fine avec lfo osc 1
byte lfofine2=0;                        // decalage freq fine avec lfo osc 2
byte lfofine3=0;                        // decalage freq fine avec lfo osc 3


//long countnote=0;
long LastMicros;

//---------------------------------------
// FIN DES DECLARATIONS FREDERIC ABIGNOLI
//---------------------------------------



// Pulse width must be less than 0x0FFF (4095)
// note - must also be higher than nothing if using a square wave
//
#define PULSE_WIDTH 0x0
// These all must be below 0x0F (15) 


// Midi Implementation Chart
// defining global Control Change implementation
#define CC_MASTER 7	//Master Volume
#define CC_INPUT  8	//Ext Input
#define CC_MODE   9 //Synth Mode
#define CC_LP     10	//LP
#define CC_BP     11	//BP
#define CC_CUT    12	//Cut
#define CC_RES    13	//Res
#define CC_HP     14	//HP
#define CC_TUNE   15	//Master Tuning
#define CC_WAVE1  16	//C1 Wave
#define CC_COARSE1  17	//C1 Coarse
#define CC_FINE1  18	//C1 Fine
#define CC_DUTY1  19	//C1 Duty
#define CC_RING1  20	//C1 Ring
#define CC_SYNC1  21	//C1 Sync
#define CC_ATTACK1  22	//C1 Attack
#define CC_DECAY1 23	//C1 Decay
#define CC_SUSTAIN1 24	//C1 Sustain
#define CC_RELEASE1  25 //C1 Release
#define CC_OUT1 26	//C1 Output
#define CC_WAVE2  32	//C2 Wave
#define CC_COARSE2  33	//C2 Coarse
#define CC_FINE2  34	//C2 Fine
#define CC_DUTY2  35	//C2 Duty
#define CC_RING2  36	//C2 Ring
#define CC_SYNC2  37	//C2 Sync
#define CC_ATTACK2  38	//C2 Attack
#define CC_DECAY2 39	//C2 Decay
#define CC_SUSTAIN2 40	//C2 Sustain
#define CC_RELEASE2 41	//C2 Release
#define CC_OUT2 42	//C2 Output
#define CC_WAVE3  48	//C3 Wave
#define CC_COARSE3  49	//C3 Coarse
#define CC_FINE3  50	//C3 Fine
#define CC_DUTY3  51	//C3 Duty
#define CC_RING3  52	//C3 Ring
#define CC_SYNC3  53	//C3 Sync
#define CC_ATTACK3  54	//C3 Attack
#define CC_DECAY3 55	//C3 Decay
#define CC_SUSTAIN3  56	//C3 Sustain
#define CC_RELEASE3 57	//C3 Release
#define CC_OUT3 58	//C3 Output

static int note_state = 0;

static const unsigned char BASE_NOTE = 12;
static const unsigned int NOTES[] = {
  274, 291, 308, 326, 346, 366, 388, 411, 435, 461, 489, 518, 549, 
  581, 616, 652, 691, 732, 776, 822, 871, 923, 978, 1036, 1097, 1163, 1232, 1305, 1383, 1465, 1552, 1644,
  1742, 1845, 1955, 2071, 2195, 2325, 2463, 2610, 2765, 2930, 3104, 3288, 3484, 3691, 3910, 4143, 4388, 4650,  
  4927, 5220, 5530, 5859, 6207, 6577, 6968, 7382, 7821, 8286, 8779, 9301, 9854, 10440, 11060, 11718, 12415, 
  13153, 13935, 14764, 15642, 16572, 17557, 18601, 19709, 20897, 22121, 23436, 24830, 26306, 27871, 29528,
  31234, 33144, 35115, 37203, 39415, 41759, 44242, 46873, 49660, 52613, 55741, 59056, 62567};

//==============================
// GLOBAL SYNTH VARIABLES INIT
//==============================
// Coarse Frequency, base 32, value from 0 (-16) to 31 (+15)
static byte coarse1 = 16;
static byte coarse2 = 16;
static byte coarse3 = 16;

// Fine Frequency, base 0 value from 0  to 127 
static byte fine1 = 0;
static byte fine2 = 0;
static byte fine3 = 0;


// Default midi channel
static byte mchannel = 1;

// Synth State Managment
static boolean trigged = false; // indicating if synth is playing
static boolean retrigger = true; // indicating if retriggering ADSR is on

// Local Osc Frequency 
// Registers @ B00000 and B00001
// Default 440hz = 0x1CD5
static word	freq1 = 0x1CD5;
static word	freq2 = 0x1CD5;
static word	freq3 = 0x1CD5;

// PWM
// Default Square Wave = 0x800  
// Formula : PWout = (PWn/40.95) %
static word	pw1 = 0x800;
static word	pw2 = 0x800;
static word	pw3 = 0x800;

// Control Register
// Default: Saw
// Content NOI|SQR|SAW|TRI|TST|MOD|SYN|GAT
static byte	ctrl1 = 0X40;
static byte	ctrl2 = 0X00;
static byte	ctrl3 = 0X00;

// Attack and Decay
// Default : Shortest
static byte	ad1 = 0x00;
static byte	ad2 = 0x00;
static byte	ad3 = 0x00;

// Sustain and Release
// Default: Max sustain and no release
static byte	sr1 = 0xF0;
static byte	sr2 = 0xF0;
static byte	sr3 = 0xF0;

// Cutoff Frequency
static word	freq = 0x7FF;

// Resonnance and CTRL
// Res= 0 no resonnance, Res=F max resonnance
// Routing 0 is no filter, 1 is filter
// RES(4)|EXT|F3|F2|F1
static byte	res = 0x00;

// Mode 
// Content EXT|HP|BP|LP|VOL(4)
static byte	mode = 0x0F;



// Mono Note Memory
static byte last_note = 0;
static byte current_note = 0;
static byte notes = 0;





// ########################################################
// Fonctions et procedures Vince
// ########################################################

SID sid;

// Give voices some initial params
//
void synth_init() 
{
  // Freq init
  sid.send(SID_FREQ1LO,char(freq1));
  sid.send(SID_FREQ1HI,char(freq1>>8));
  sid.send(SID_FREQ2LO,char(freq2));
  sid.send(SID_FREQ2HI,char(freq2>>8));
  sid.send(SID_FREQ3LO,char(freq3));
  sid.send(SID_FREQ3HI,char(freq3>>8));


  // PWM Init
  sid.send(SID_PW1LO,char(pw1));
  sid.send(SID_PW1HI,char(pw1>>8));
  sid.send(SID_PW2LO,char(pw2));
  sid.send(SID_PW2HI,char(pw2>>8));
  sid.send(SID_PW3LO,char(pw3));
  sid.send(SID_PW3HI,char(pw3>>8));


  // ADSR
  sid.send(SID_AD1,ad1);
  sid.send(SID_SR1,sr1);
  sid.send(SID_AD2,ad2);
  sid.send(SID_SR2,sr2);
  sid.send(SID_AD3,ad3);
  sid.send(SID_SR3,sr3);

  // Filter + Main
  sid.send(SID_FCLO,char(freq));
  sid.send(SID_FCHI,char(freq>>3));
  sid.send(SID_RES,res);
  sid.send(SID_MODE,mode);

  // PWM Init
  sid.send(SID_PW1LO,char(pw1));
  sid.send(SID_PW1HI,char(pw1>>8));
  sid.send(SID_PW2LO,char(pw2));
  sid.send(SID_PW2HI,char(pw2>>8));
  sid.send(SID_PW3LO,char(pw3));
  sid.send(SID_PW3HI,char(pw3>>8));
/*
  // Pas utile pour l'initalisation
  // dans la mesure où les reg ctrlx
  // sont envoyes a chaque note-on
  // CTRL
  sid.send(SID_CTRL1,ctrl1);
  sid.send(SID_CTRL2,ctrl2);
  sid.send(SID_CTRL3,ctrl3);

*/
  
}

//-----------------------------------------------------
// Play sound at frequency specified on voice specified
//-----------------------------------------------------
void synth_on(int note) 
{
#if defined(OPTIFREQ)
word lastfreq;
    // RAZ Lfo2 (Synchronise sur note on)
    //Lfo2Pos=0;
    // Memorisation registre freq1
    lastfreq=freq1;               
    // Calcul de la frequence        
    freq1=NOTES[note+coarse1-16]+fine1+lfofine1;
    // Si la frequence a changee depuis la precedente note
    // alors on met a jour le SID, sinon la frequence a deja ete calculee
    if (lastfreq!=freq1) {
      sid.send(SID_FREQ1LO,char(freq1));
      sid.send(SID_FREQ1HI,char(freq1>>8));
    }
    
    lastfreq=freq2;
    freq2=NOTES[note+coarse2-16]+fine2+lfofine2;
    if (lastfreq!=freq2) {
      sid.send(SID_FREQ2LO,char(freq2));
      sid.send(SID_FREQ2HI,char(freq2>>8));
    }
    lastfreq=freq3;
    freq3=NOTES[note+coarse3-16]+fine3+lfofine3;
    if (lastfreq!=freq3) {
      sid.send(SID_FREQ3LO,char(freq3));
      sid.send(SID_FREQ3HI,char(freq3>>8));
    }
#else
    // RAZ Lfo2 (Synchronise sur note on)
    //Lfo2Pos=0;
    // Calcul freq 1
    freq1=NOTES[note+coarse1-16]+fine1+lfofine1;
    // MAJ SID freq 1
    sid.send(SID_FREQ1LO,char(freq1));
    sid.send(SID_FREQ1HI,char(freq1>>8));
    // Calcul freq 2
    freq2=NOTES[note+coarse2-16]+fine2+lfofine2;
    // MAJ SID freq 2
    sid.send(SID_FREQ2LO,char(freq2));
    sid.send(SID_FREQ2HI,char(freq2>>8));
    // Calcul freq 3
    freq3=NOTES[note+coarse3-16]+fine3+lfofine3;
    // MAJ SID freq 3
    sid.send(SID_FREQ3LO,char(freq3));
    sid.send(SID_FREQ3HI,char(freq3>>8));
#endif

#if defined(OPTIGATEON)
  // n'ouvrir le gate que si cest necessaire
  // uniquement si une forme d'onde a ete choisie
  // Si pas de forme donde, on n'ouvre pas le gate pour rien
  // cela evite d'entendre l'ouverture du VCA pour la voix courante
  // on gagne aussi du temps
  if (ctrl1>>4) {
    ctrl1|=1;
    sid.send(SID_CTRL1,ctrl1);
  }
  if (ctrl2>>4) {
    ctrl2|=1;
    sid.send(SID_CTRL2,ctrl2);
  }
  if (ctrl3>>4) {
    ctrl3|=1;
    sid.send(SID_CTRL3,ctrl3);
  }
#else
  // Pas d'optimisation
  // ouverture systematique des 3 gates
    ctrl1|=1;
    sid.send(SID_CTRL1,ctrl1);
    ctrl2|=1;
    sid.send(SID_CTRL2,ctrl2);
    ctrl3|=1;
    sid.send(SID_CTRL3,ctrl3);
#endif
}

//-------------------------------------------
// Fermeture des gates sur les 3 oscillateurs
//-------------------------------------------
void synth_off(int note) 
{
  // Ne fermer les gates que s'ils sont ouvert
  // bit 0 à 1 si ouvert
  // En test. Supprimé pour l'instant.
#if defined(OPTIGATEOFF)  
  if (ctrl1 & 1) {              // Voice 1
    ctrl1&=~1;
    sid.send(SID_CTRL1,ctrl1);
  }
  if (ctrl2 & 1) {              // Voice 2
    ctrl2&=~1;
    sid.send(SID_CTRL2,ctrl2);
  }
  if (ctrl3 & 1) {              // Voice 3
    ctrl3&=~1;
    sid.send(SID_CTRL3,ctrl3);
  }
#else
    ctrl1&=~1;
    sid.send(SID_CTRL1,ctrl1);
    ctrl2&=~1;
    sid.send(SID_CTRL2,ctrl2);
    ctrl3&=~1;
    sid.send(SID_CTRL3,ctrl3);
#endif
}

// Note On Handler
// PS : The if / else is implemented because some Midi equipements 
//do not use Note Off, but use instead note On with velocity = 0 
void DoHandleNoteOn (byte channel, byte note, byte velocity) {
  if( velocity==0 ) { 
    notes--;
    if (notes==0) {
      synth_off(note);
    }
    else {
      if (note==current_note) {
        synth_on(last_note);
        current_note=last_note;
      }
      current_note=last_note;
    }
  }
  else { 
    synth_on(note); 
    last_note = current_note;
    current_note = note;
    notes++;
  }
}

//------------------------------
// Note off handler pour le midi
//------------------------------
void DoHandleNoteOff (byte channel, byte note, byte velocity) {
  notes--;
  // Ajout si notes passe en dessous de 0 (donc 255 car byte non signe)
  if (notes==255)
      notes=0;
  if (notes==0) {
    synth_off(note);
  }
  else {
    if (note==current_note) {
      synth_on(last_note);
      current_note=last_note;
    }
    current_note=last_note;
  }
}


//-----------------------------------------------
// Control change handler pour le midi
// modifie chaque parametre du SID
// est appele par MIDI.Read() a reception d'un CC
// ou bien directement via interface utilisateur
//-----------------------------------------------
void DoHandleControlChange (byte channel, byte number, byte value) {
int myint;
word myword;
byte mybyte;
  switch (number) {

  case CC_CUT:
    freq = value<<4;
    // Sauvegarde registre freq
    myword=freq;
    // Gestion LFO1
    if (Lfo1Dest==7) {
        myint=freq-((Lfo1Level/4)*Lfo1Val);
        if (myint<0)
           freq=0;
        else
           freq=myint;
    }
    // ou LFO2
    if (Lfo2Dest==7) {
        myint=freq-((Lfo2Level/4)*Lfo2Val);
        if (myint<0)
            freq=0;
        else
            freq=myint;
    }
    sid.send(SID_FCLO,char(freq));
    sid.send(SID_FCHI,char(freq>>3));
    // restauration registre interne freq
    if (Lfo1Dest==7 || Lfo2Dest==7)
      freq=myword;
    if (ym==0 && xm==3 && !RPAGE) 
      digitsLcd(freq>>4,0,3,3);
    break;

  case CC_RES:
    mybyte=res;
    value = (value<<1)&0xF0;
    // Gestion LFO1
    if (Lfo1Dest==8) {
        value=value+((Lfo1Level/4)*Lfo1Val);
        if (value>240)
           value=240;
    }
    // ou LFO2
    if (Lfo2Dest==8) {
        myint=freq-((Lfo2Level/4)*Lfo2Val);
        if (myint<0)
            freq=0;
        else
            freq=myint;
    }
    value &=0xF0;
    res &= 0x0F;
    res |= value;
    sid.send(SID_RES,res);
    // restauration registre interne res
    if (Lfo1Dest==8 || Lfo2Dest==8)
      res=mybyte;
    
    if (ym==0 && xm==3 && !RPAGE) 
      digitsLcd(res>>4,6,3,2);
    break;
  // Ajout de fred  
  // Gestion du volume global
  case CC_MASTER:
    value = (value>>3)&0x0F;
    mode &= 0xF0;
    mode |= value;
    sid.send(SID_MODE,mode);
    if (ym==1 && xm==3 && !RPAGE) 
      digitsLcd((mode & 0x0F),16,3,2);
    break;

  case CC_LP:
    if (value>63) {
      mode|=16; 
    }
    else {  
      mode&=~16; 
    }
    sid.send(SID_MODE,mode);
    if (ym==1 && xm==3 && !RPAGE) 
      OnOffLcd(mode & 16,11,3);
    break;

  case CC_BP:
    if (value>63) {
      mode|=32; 
    }
    else {  
      mode&=~32; 
    }
    sid.send(SID_MODE,mode);
    if (ym==1 && xm==3 && !RPAGE) 
      OnOffLcd(mode & 32,6,3);
    break;

  case CC_HP:
    if (value>63) {
      mode|=64; 
    }
    else {  
      mode&=~64; 
    }
    sid.send(SID_MODE,mode);
    if (ym==1 && xm==3 && !RPAGE) 
      OnOffLcd(mode & 64,1,3);
    break;

    // channel 1

  case CC_ATTACK1:
    ad1 &= 0x0F;
    value = (value<<1)&0xF0;
    ad1 |= value;
    sid.send(SID_AD1,ad1);
    if (ym==1 && xm==0 && !RPAGE) 
      digitsLcd(ad1>>4,1,3,2);
    break;

  case CC_DECAY1:
    ad1 &= 0xF0;
    ad1 |= (value>>3);
    sid.send(SID_AD1,ad1);
    if (ym==1 && xm==0 && !RPAGE) 
      digitsLcd((ad1 & 0x0F),6,3,2);
    break;

  case CC_SUSTAIN1:
    sr1 &= 0x0F;
    value = (value<<1)&0xF0;
    sr1 |= value;
    sid.send(SID_SR1,sr1);
    if (ym==1 && xm==0 && !RPAGE) 
      digitsLcd(sr1>>4,11,3,2);
    break;

  case CC_RELEASE1:
    sr1 &= 0xF0;
    sr1 |= (value>>3);
    sid.send(SID_SR1,sr1);
    if (ym==1 && xm==0 && !RPAGE) 
      digitsLcd((sr1 & 0x0F),16,3,2);
    break;

  case CC_COARSE1:
    coarse1 = value>>2;
    freq1=NOTES[current_note+coarse1-16]+fine1+lfofine1;
    sid.send(SID_FREQ1LO,char(freq1));
    sid.send(SID_FREQ1HI,char(freq1>>8));
    if (ym==2 && xm==0 && !RPAGE) {
      myInt=coarse1-16;
      lcd.setCursor(0,3);
      if (myInt<0) { 
        lcd.print(F("-"));
        myInt*=-1;
      }
      else {
          lcd.print(F(" "));
      }
     digitsLcd(myInt,1,3,2);    
    } 
    break;

  case CC_FINE1:
    fine1 = value;
    // Gestion LFOS
    // Si destination FINE1
    if (Lfo1Dest==4) {
        lfofine1=((Lfo1Level*Lfo1Val)/64);
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination FINE1
      if (Lfo2Dest==4) {
        lfofine1=((Lfo2Level*Lfo2Val)/64);
      }
    }
    freq1=NOTES[current_note+coarse1-16]+fine1+lfofine1;
    sid.send(SID_FREQ1LO,char(freq1));
    sid.send(SID_FREQ1HI,char(freq1>>8));
    if (ym==2 && xm==0 && !RPAGE) 
      digitsLcd(fine1,5,3,3); 
    break;

  case CC_SYNC1:
    if (value>63) {
      ctrl1|=2; 
    }
    else {  
      ctrl1&=~2; 
    }
    sid.send(SID_CTRL1,ctrl1);
    if (ym==0 && xm==0 && !RPAGE) 
      OnOffLcd(ctrl1 & 2,11,3);
    break;

  case CC_RING1:
    if (value>63) {
      ctrl1|=4; 
    }
    else {  
      ctrl1&=~4; 
    }
    sid.send(SID_CTRL1,ctrl1);
    if (ym==0 && xm==0 && !RPAGE) 
      OnOffLcd(ctrl1 & 4,16,3);
    break;    

  case CC_WAVE1:
    value= value >>4;
    ctrl1&=0x0F;
    switch (value) {
    case 0:
      value = 0;
      break;
    case 1:
      value = 16;
      break;
    case 2:
      value = 32;
      break;
    case 3:
      value = 64;
      break;
    default:
      value = 128;
      break;
    }
    ctrl1|=value;
    sid.send(SID_CTRL1,ctrl1);
    if (ym==0 && xm==0 && !RPAGE) 
      WaveLCD(ctrl1>>4,0,3);
    break; 

  case CC_OUT1:
    if (value>63) {
      res|=1; 
    }
    else {  
      res&=~1; 
    }
    sid.send(SID_RES,res);
    if (ym==2 && xm==3 && !RPAGE) 
      OnOffLcd((res & 1),1,3);
    break;

  case CC_DUTY1:
    // sauvegarde valeur pwm3
    pw1 = value<<3+1;  
    myword=pw1;
    myint=value;
    // Gestion LFOS
    // Si destination PWM1
    if (Lfo1Dest==1) {
        myint=myint-((Lfo1Level*Lfo1Val)/64);
        // au cas ou...
        if (myint < 1)
            myint=1;
        pw1 = (byte)myint<<3+1;
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination PWM1
      if (Lfo2Dest==1) {
        myint=myint-((Lfo2Level*Lfo2Val)/64);
          if (myint < 1)
              myint=1;
          pw1 = (byte)myint<<3+1;
      }
    }
    sid.send(SID_PW1LO,char(pw1));
    sid.send(SID_PW1HI,char(pw1>>8));

    // restaurer valeur origine de pw1
    // si modifiee par LFO
    if (Lfo1Dest==1 || Lfo2Dest==1) 
      pw1 = myword;
    if (ym==0 && xm==0 && !RPAGE) 
      digitsLcd(pw1>>4,5,3,3);
    break;

    //channel 2

  case CC_ATTACK2:
    ad2 &= 0x0F;
    value = (value<<1)&0xF0;
    ad2 |= value;
    sid.send(SID_AD2,ad2);
    if (ym==1 && xm==1 && !RPAGE) 
      digitsLcd(ad2>>4,1,3,2);
    break;

  case CC_DECAY2:
    ad2 &= 0xF0;
    ad2 |= (value>>3);
    sid.send(SID_AD2,ad2);
    if (ym==1 && xm==1 && !RPAGE) 
      digitsLcd((ad2 & 0x0F),6,3,2);
    break;

  case CC_SUSTAIN2:
    sr2 &= 0x0F;
    value = (value<<1)&0xF0;
    sr2 |= value;
    sid.send(SID_SR2,sr2);
    if (ym==1 && xm==1 && !RPAGE) 
      digitsLcd(sr2>>4,11,3,2);
    break;

  case CC_RELEASE2:
    sr2 &= 0xF0;
    sr2 |= (value>>3);
    sid.send(SID_SR2,sr2);
    if (ym==1 && xm==1 && !RPAGE) 
      digitsLcd((sr2 & 0x0F),16,3,2);
    break;

  case CC_COARSE2:
    coarse2 = value>>2;
    freq2=NOTES[current_note+coarse2-16]+fine2+lfofine2;
    sid.send(SID_FREQ2LO,char(freq2));
    sid.send(SID_FREQ2HI,char(freq2>>8));
    if (ym==2 && xm==1 && !RPAGE) {
      myInt=coarse2-16;
      lcd.setCursor(0,3);
      if (myInt<0) { 
        lcd.print(F("-"));
        myInt*=-1;
      }
      else {
          lcd.print(F(" "));
      }
     digitsLcd(myInt,1,3,2);    
    } 
    break;

  case CC_FINE2:
    fine2 = value;
    // Gestion LFOS
    // Si destination FINE1
    if (Lfo1Dest==5) {
        lfofine2=((Lfo1Level*Lfo1Val)/64);
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination FINE1
      if (Lfo2Dest==5) {
        lfofine2=((Lfo2Level*Lfo2Val)/64);
      }
    }
    freq2=NOTES[current_note+coarse2-16]+fine2+lfofine2;
    sid.send(SID_FREQ2LO,char(freq2));
    sid.send(SID_FREQ2HI,char(freq2>>8));
    if (ym==2 && xm==1 && !RPAGE) 
      digitsLcd(fine2,5,3,3);
    break;

  case CC_SYNC2:
    if (value>63) {
      ctrl2|=2; 
    }
    else {  
      ctrl2&=~2; 
    }
    sid.send(SID_CTRL2,ctrl2);
    if (ym==0 && xm==1 && !RPAGE) 
      OnOffLcd(ctrl2 & 2,11,3);
    break;

  case CC_RING2:
    if (value>63) {
      ctrl2|=4; 
    }
    else {  
      ctrl2&=~4; 
    }
    sid.send(SID_CTRL2,ctrl2);
    if (ym==0 && xm==1 && !RPAGE) 
      OnOffLcd(ctrl2 & 4,16,3);
    break;    

  case CC_WAVE2:
    value= value >>4;
    ctrl2&=0x0F;
    switch (value) {
    case 0:
      value = 0;
      break;
    case 1:
      value = 16;
      break;
    case 2:
      value = 32;
      break;
    case 3:
      value = 64;
      break;
    default:
      value = 128;
      break;
    }
    ctrl2|=value;
    sid.send(SID_CTRL2,ctrl2);
    if (ym==0 && xm==1 && !RPAGE) 
      WaveLCD(ctrl2>>4,0,3);
    break; 

  case CC_OUT2:
    if (value>63) {
      res|=2; 
    }
    else {  
      res&=~2; 
    }
    sid.send(SID_RES,res);
    if (ym==2 && xm==3 && !RPAGE) 
      OnOffLcd((res & 2),6,3);
    break;    

  case CC_DUTY2:
    pw2 = value<<3+1;  
    myint=value;
    // sauvegarde valeur
    myword=pw2;
    
    // Gestion LFOS
    // Si destination PWM2
    if (Lfo1Dest==2) {
        myint=myint-((Lfo1Level*Lfo1Val)/64);
        // au cas ou...
        if (myint < 1)
            myint=1;
        pw2 = (byte)myint<<3+1;
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination PWM1
      if (Lfo2Dest==2) {
        myint=myint-((Lfo2Level*Lfo2Val)/64);
          if (myint < 1)
              myint=1;
          pw2 = (byte)myint<<3+1;
      }
    }
    sid.send(SID_PW2LO,char(pw2));
    sid.send(SID_PW2HI,char(pw2>>8));
    // restaurer valeur origine de pw2
    // si modifiee par LFO
    if (Lfo1Dest==2 || Lfo2Dest==2) 
      pw2 = myword;
    if (ym==0 && xm==1 && !RPAGE) 
      digitsLcd(pw2>>4,5,3,3);
    break;    

    //channel 3

  case CC_ATTACK3:
    ad3 &= 0x0F;
    value = (value<<1)&0xF0;
    ad3 |= value;
    sid.send(SID_AD3,ad3);
    if (ym==1 && xm==2 && !RPAGE) 
      digitsLcd(ad3>>4,1,3,2);
    break;

  case CC_DECAY3:
    ad3 &= 0xF0;
    ad3 |= (value>>3);
    sid.send(SID_AD3,ad3);
    if (ym==1 && xm==2 && !RPAGE) 
      digitsLcd((ad3 & 0x0F),6,3,2);
    break;

  case CC_SUSTAIN3:
    sr3 &= 0x0F;
    value = (value<<1)&0xF0;
    sr3 |= value;
    sid.send(SID_SR3,sr3);
    if (ym==1 && xm==2 && !RPAGE) 
      digitsLcd(sr3>>4,11,3,2);
    break;

  case CC_RELEASE3:
    sr3 &= 0xF0;
    sr3 |= (value>>3);
    sid.send(SID_SR3,sr3);
    if (ym==1 && xm==2 && !RPAGE) 
      digitsLcd((sr3 & 0x0F),16,3,2);
    break;

  case CC_COARSE3:
    coarse3 = value>>2;
    freq3=NOTES[current_note+coarse3-16]+fine3+lfofine3;
    sid.send(SID_FREQ3LO,char(freq3));
    sid.send(SID_FREQ3HI,char(freq3>>8));
    if (ym==2 && xm==2 && !RPAGE) {
      myInt=coarse3-16;
      lcd.setCursor(0,3);
      if (myInt<0) { 
        lcd.print(F("-"));
        myInt*=-1;
      }
      else {
          lcd.print(F(" "));
      }
     digitsLcd(myInt,1,3,2);    
    } 
    break;

  case CC_FINE3:
    fine3 = value;
    // Gestion LFOS
    // Si destination FINE1
    if (Lfo1Dest==6) {
        lfofine3=((Lfo1Level*Lfo1Val)/64);
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination FINE1
      if (Lfo2Dest==6) {
        lfofine3=((Lfo2Level*Lfo2Val)/64);
      }
    }
    freq3=NOTES[current_note+coarse3-16]+fine3+lfofine3;
    sid.send(SID_FREQ3LO,char(freq3));
    sid.send(SID_FREQ3HI,char(freq3>>8));
    if (ym==2 && xm==2 && !RPAGE) 
      digitsLcd(fine3,5,3,3);
    break;

  case CC_SYNC3:
    if (value>63) {
      ctrl3|=2; 
    }
    else {  
      ctrl3&=~2; 
    }
    sid.send(SID_CTRL3,ctrl3);
    if (ym==0 && xm==2 && !RPAGE) 
      OnOffLcd(ctrl3 & 2,11,3);
    break;

  case CC_RING3:
    if (value>63) {
      ctrl3|=4; 
    }
    else {  
      ctrl3&=~4; 
    }
    sid.send(SID_CTRL3,ctrl3);
    if (ym==0 && xm==2 && !RPAGE) 
      OnOffLcd(ctrl3 & 4,16,3);
    break;    

  case CC_WAVE3:
    value= value >>4;
    ctrl3&=0x0F;
    switch (value) {
    case 0:
      value = 0;
      break;
    case 1:
      value = 16;
      break;
    case 2:
      value = 32;
      break;
    case 3:
      value = 64;
      break;
    default:
      value = 128;
      break;
    }
    ctrl3|=value;
    sid.send(SID_CTRL3,ctrl3);
    if (ym==0 && xm==2 && !RPAGE) 
      WaveLCD(ctrl3>>4,0,3);
    break; 

  case CC_OUT3:
    if (value>63) {
      res|=4; 
    }
    else {  
      res&=~4; 
    }
    sid.send(SID_RES,res);
    if (ym==2 && xm==3 && !RPAGE) 
      OnOffLcd((res & 4),11,3);
    break;    
  // Ajout Fred
  // Gestion entree externe
  case CC_INPUT:
    if (value>63) {
      res|=8; 
    }
    else {  
      res&=~8; 
    }
    sid.send(SID_RES,res);
    if (ym==2 && xm==3 && !RPAGE) 
      OnOffLcd((res & 8),16,3);
    break;    

  case CC_DUTY3:
    pw3 = value<<3+1;
    myint=value;
    // sauvegarde valeur pwm3
    myword=pw3;
    // Gestion LFOS
    // Si destination PWM3
    if (Lfo1Dest==3) {
        myint=myint-((Lfo1Level*Lfo1Val)/64);
        // au cas ou...
        if (myint < 1)
            myint=1;
        pw3 = (byte)myint<<3+1;
    }
    else {
      // ou LFO2 si pas de selection de LFO1
      // Si destination PWM1
      if (Lfo2Dest==3) {
        myint=myint-((Lfo2Level*Lfo2Val)/64);
          if (myint < 1)
              myint=1;
          pw3 = (byte)myint<<3+1;
      }
    }
    sid.send(SID_PW3LO,char(pw3));
    sid.send(SID_PW3HI,char(pw3>>8));
    // restaurer valeur origine de pw1
    // si modifiee par LFO
    if (Lfo1Dest==3 || Lfo2Dest==3) 
      pw3 = myword;
    if (ym==0 && xm==2 && !RPAGE)            
      digitsLcd(pw3>>4,5,3,3);
    break;    

  }

}

// ########################################################
// Fonctions et procedures F. ABIGNOLI
// ########################################################

//-------------------------------------------------------------
// Routine ecriture d'un octet en eeprom
// Param 1 adresse I2C (defaut 0x50 avec pins 1,2,3 a la masse)
// param 2 adresse memoire a ecrire (de 0 à 32767 pour 24LC256)
// param 3 octet a ecrire
//-------------------------------------------------------------
void eewrite_byte( int deviceaddress, unsigned int eeaddress, byte data ) 
{
int rdata = data;
  Wire.beginTransmission(deviceaddress);// Selection du device
  Wire.write((int)(eeaddress >> 8));    // MSB
  Wire.write((int)(eeaddress & 0xFF));  // LSB
  Wire.write(rdata);                    // Ecriture
  Wire.endTransmission();               // Fin de transmission
  delay(5);                             // Attente pour flush
}

//-------------------------------------------------------------
// Routine lecture d'un octet en eeprom
// Param 1 adresse I2C (defaut 0x50 avec pins 1,2,3 a la masse)
// param 2 adresse memoire à lire (de 0 à 32767 pour 24LC256)
//-------------------------------------------------------------
byte eeread_byte( int deviceaddress, unsigned int eeaddress ) {
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);      // Selection du device
  Wire.write((int)(eeaddress >> 8));          // MSB
  Wire.write((int)(eeaddress & 0xFF));        // LSB
  Wire.endTransmission();                     // Fin de transmission
  Wire.requestFrom(deviceaddress,1);          // Requete 1 octet
  if (Wire.available()) rdata = Wire.read();  // Lecture tant que possible
    return rdata;                             // Retourner la donnee
}

//---------------------------------------
// Sauvegarde dun preset
// param 1 :  numero de la banque (O a 3)
// param 2 :  numero du preset (0 à 127)
//---------------------------------------
void save_preset(byte mybank,byte mypreset)
{
int i;
int myaddress=0;
    // Initialisation de l'adresse du preset
    myaddress=(mybank*BANKSIZE)+(mypreset*PRESETSIZE);
    // Nom du preset
    for (i=0;i<16;i++) { 
      eewrite_byte( 0x50, myaddress++, nomPreset[i]);
    }
    // Tuning cooarse
    eewrite_byte( 0x50, myaddress++, coarse1);
    eewrite_byte( 0x50, myaddress++, coarse2);
    eewrite_byte( 0x50, myaddress++, coarse3);
    // Tuning fine
    eewrite_byte( 0x50, myaddress++, fine1);
    eewrite_byte( 0x50, myaddress++, fine2);
    eewrite_byte( 0x50, myaddress++, fine3);
    // PWM
    eewrite_byte( 0x50, myaddress++, highByte(pw1));
    eewrite_byte( 0x50, myaddress++, lowByte(pw1));
    eewrite_byte( 0x50, myaddress++, highByte(pw2));
    eewrite_byte( 0x50, myaddress++, lowByte(pw2));
    eewrite_byte( 0x50, myaddress++, highByte(pw3));
    eewrite_byte( 0x50, myaddress++, lowByte(pw3));
    // Controle
    eewrite_byte( 0x50, myaddress++, ctrl1);
    eewrite_byte( 0x50, myaddress++, ctrl2);
    eewrite_byte( 0x50, myaddress++, ctrl3);
    // Attaque, decay
    eewrite_byte( 0x50, myaddress++, ad1);
    eewrite_byte( 0x50, myaddress++, ad2);
    eewrite_byte( 0x50, myaddress++, ad3);
    // Sustain, release
    eewrite_byte( 0x50, myaddress++, sr1);
    eewrite_byte( 0x50, myaddress++, sr2);
    eewrite_byte( 0x50, myaddress++, sr3);
    // Frequence filtre
    eewrite_byte( 0x50, myaddress++, highByte(freq));
    eewrite_byte( 0x50, myaddress++, lowByte(freq));
    // Resonnance filtre
    eewrite_byte( 0x50, myaddress++, res);
    // Mode filtre et volume
    eewrite_byte( 0x50, myaddress++, mode);
    // Future gestion LFO
    eewrite_byte( 0x50, myaddress++, Lfo1Speed);
    eewrite_byte( 0x50, myaddress++, Lfo2Speed);
    eewrite_byte( 0x50, myaddress++, Lfo1Wave);
    eewrite_byte( 0x50, myaddress++, Lfo2Wave);
    eewrite_byte( 0x50, myaddress++, Lfo1Dest);
    eewrite_byte( 0x50, myaddress++, Lfo2Dest);
    eewrite_byte( 0x50, myaddress++, Lfo1Level);
    eewrite_byte( 0x50, myaddress++, Lfo2Level);
}

//-----------------------------------------------
// Chargement dun preset
// param 1 :  numero de la banque (O a 3)
// param 2 :  numero du preset (0 à 127)
// Charge les donnees dans les variables globales
//-----------------------------------------------
void load_preset(byte mybank,byte mypreset)
{
int i;
int myaddress=0;

    // Initialisation de l'adresse du preset
    myaddress=(mybank*BANKSIZE)+(mypreset*PRESETSIZE);
    // Nom du preset
    memset(nomPreset,0,sizeof(nomPreset));
    for (i=0;i<16;i++) {
      nomPreset[i]=eeread_byte( 0x50, myaddress++);
    }
    // Tuning cooarse
    coarse1=eeread_byte( 0x50, myaddress++);
    coarse2=eeread_byte( 0x50, myaddress++);
    coarse3=eeread_byte( 0x50, myaddress++);
    // Tuning fine
    fine1=eeread_byte( 0x50, myaddress++);
    
    fine2=eeread_byte( 0x50, myaddress++);
    
    fine3=eeread_byte( 0x50, myaddress++);
    
    // PWM
    myByte1=eeread_byte( 0x50, myaddress++);
    myByte2=eeread_byte( 0x50, myaddress++);
    pw1=word(myByte1,myByte2);
    myByte1=eeread_byte( 0x50, myaddress++);
    myByte2=eeread_byte( 0x50, myaddress++);
    pw2=word(myByte1,myByte2);
    myByte1=eeread_byte( 0x50, myaddress++);
    myByte2=eeread_byte( 0x50, myaddress++);
    pw3=word(myByte1,myByte2);

    // Controle
    ctrl1=eeread_byte( 0x50, myaddress++);
    ctrl2=eeread_byte( 0x50, myaddress++);
    ctrl3=eeread_byte( 0x50, myaddress++);
    
    // Attaque, decay
    ad1=eeread_byte( 0x50, myaddress++);
    ad2=eeread_byte( 0x50, myaddress++);
    ad3=eeread_byte( 0x50, myaddress++);
    
    // Sustain, release
    sr1=eeread_byte( 0x50, myaddress++);
    sr2=eeread_byte( 0x50, myaddress++);
    sr3=eeread_byte( 0x50, myaddress++);
    
    // Frequence filtre
    myByte1=eeread_byte( 0x50, myaddress++);
    myByte2=eeread_byte( 0x50, myaddress++);
    freq=word(myByte1,myByte2);

    // Resonnance filtre
    res=eeread_byte( 0x50, myaddress++);
    
    // Mode filtre et volume
    mode=eeread_byte( 0x50, myaddress++);
    
    // Future gestion LFO
    Lfo1Speed=eeread_byte( 0x50, myaddress++);
    Lfo2Speed=eeread_byte( 0x50, myaddress++);
    Lfo1Wave=eeread_byte( 0x50, myaddress++);
    Lfo2Wave=eeread_byte( 0x50, myaddress++);
    Lfo1Dest=eeread_byte( 0x50, myaddress++);
    Lfo2Dest=eeread_byte( 0x50, myaddress++);
    Lfo1Level=eeread_byte( 0x50, myaddress++);
    Lfo2Level=eeread_byte( 0x50, myaddress++);
    synth_init();
}

//-----------------------------------------------------------
// charge un nom du preset dans la variable globale nomPreset
//-----------------------------------------------------------
void load_preset_name(byte mybank,byte mypreset)
{
int i;
int myaddress=0;

    memset(nomPreset,0,sizeof(nomPreset));
    // Initialisation de l'adresse du preset
    myaddress=(mybank*BANKSIZE)+(mypreset*PRESETSIZE);
    // Nom du preset
    for (i=0;i<16;i++) {
      nomPreset[i]=eeread_byte( 0x50, myaddress++);
    }
}


//-----------------------------
// RAZ PRESET COURANT
// pour init utilisateur
// ou en cas de saturation midi 
//-----------------------------
void preset_init(void)
{
   
  // Frequence 440hz
  freq1 = 0x1CD5;
  freq2 = 0x1CD5;
  freq3 = 0x1CD5;
  // PWM =  signal carre
  pw1 = 0x800;
  pw2 = 0x800;
  pw3 = 0x800;
  // Triangle voix 1
  // rien pour voix 2 et 3
  ctrl1 = 0X40;   
  ctrl2 = 0X00;   
  ctrl3 = 0X00;   
  // Attack 0, decay 0, sustain 15 (maxi), release 0
  ad1 = 0x00;     
  ad2 = 0x00;
  ad3 = 0x00;
  sr1 = 0xF0;
  sr2 = 0xF0;
  sr3 = 0xF0;
  // Filtre ouvert au maxi
  freq = 0x7FF;
  // Pas de resonnance
  res = 0x00;
  // Volume maxi, pas de filtrage
  mode = 0x0F;
  synth_init();
}



//-----------------------------------------
// Initialise les parametres necessaire
// pour execution d'une ISR par le timer 2
// toutes les 2ms, afin de lire la position
// des 4 encodeurs rotatifs
//-----------------------------------------
void encodeursSetup(void) 
{
byte i;
  //-------------------------------------
  // Initialisation des pin des encodeurs
  // Mode input
  // Resistance pull-up activee
  //-------------------------------------
  for(i=0;i<4;i++) {
    pinMode(pinA[i], INPUT);
    pinMode(pinB[i], INPUT);
    digitalWrite(pinA[i],HIGH);
    digitalWrite(pinB[i],HIGH);
  }

  //----------------------------------------
  // Configuration du timer 2
  // Pour la lecture des encodeurs
  // Execution de la routine d'interruption
  // toutes les 2ms (par overflow)
  //----------------------------------------
  TIMSK2 &= ~(1<<TOIE2);  
  // Timer 2 en mode normal
  TCCR2A &= ~((1<<WGM21) | (1<<WGM20));  
  TCCR2B &= ~(1<<WGM22);  
  // Horloge interne
  ASSR &= ~(1<<AS2);  
  // Mode overflow
  TIMSK2 &= ~(1<<OCIE2A);  
  // Prescaler a 256
  TCCR2B |= (1<<CS22)  | (1<<CS21) ; // Set bits  
  TCCR2B &= ~(1<<CS20);              // Clear bit  
  // Sauvegarde de la valeur pou reloader dans l'ISR
  tcnt2 = 131;   
  // Chargement et mise en route du timer
  TCNT2 = tcnt2;  
  TIMSK2 |= (1<<TOIE2);
}

//--------------------------------------
// Close Encounters of the Third Kind 8)
//--------------------------------------
void zicIntro(void)
{
byte myNote[] = {38,40,36,24,31};
  for (myByte1=0; myByte1<5; myByte1++) {
    synth_on(myNote[myByte1]);
    if (myByte1==5)
      delay(2500);
    else
      delay(500);
    synth_off(myNote[myByte1]);
  }
}

//----------------------
// initialisation du LCD
//----------------------
void lcdSetup(void)
{
  lcd.init();             // init du lcd 
  lcd.backlight();        // Retroeclairage
    lcd.createChar(0, symbup);      // Creation fleche UP 
  lcd.createChar(1, symbdown);    // Creation fleche DOWN

  lcd.clear();            // Effacement de lecran
  lcd.setCursor(0,0);
  // Avec le depassement a l'affichage
  // L'ecran s'affichera avec les lignes 2 et 3 inversee
  lcd.print(F("********************"));
  lcd.print(F("*   encoders v0.9  *"));
  lcd.print(F("* MIDI SIDaster v5 *"));
  lcd.print(F("********************"));
}

//----------------------------------------
// Routine executee tous les 2ms
// par overflow sur le compteur du timer 2
//----------------------------------------
ISR(TIMER2_OVF_vect) {  
int MSB;
int LSB;
int encoded;
int sum;
byte i;
  TCNT2 = tcnt2;      // Reload du timer
  // Lecture des 4 encodeurs
  for (i=0;i<4;i++) {  
    MSB = digitalRead(pinA[i]); // MSB = most significant bit
    LSB = digitalRead(pinB[i]); // LSB = least significant bit
    encoded = (MSB << 1) |LSB; // conversion
    sum  = (lastEncoded[i] << 2) | encoded; // Ajout a la valeur precedent
    // Test si on avance
    if(sum == 0b1101 || sum == 0b0100 || sum == 0b0010 || sum == 0b1011) 
      counter[i]++;
    // Test si on recule  
    if(sum == 0b1110 || sum == 0b0111 || sum == 0b0001 || sum == 0b1000)    
      counter[i]--;                                                       
    lastEncoded[i] = encoded;   // On memorise la valeur pour la prochaine fois
    bcounter[i]=counter[i]>>2;  // Compteur utilisateur divise par 4
  }

}



//--------------------------------------------
// Routine principale de lecture des encodeurs
//--------------------------------------------
byte readEncodeurs(void) {
byte i,val;
  val=0;
  // Lire les 4 encodeurs
  for (i=0;i<4;i++) {
    // si la valeur a variee pour un des encodeurs
    if (lcounter[i]!=bcounter[i]) {
      // Tester le send
      // Si UP valeur de 11 a 14
      if (bcounter[i]>lcounter[i])
        val=i+11;
      // Si down valeur de 1 a 4
      else
        val=i+1;
      lcounter[i]=bcounter[i];
      return val;
    }
  }
  return 0;
}

//-------------------------------------------
// Lit les boutons et renvoie la valeurs lues
// Ne permet qu'une saisie quand un bouton
// est appuyé
//-------------------------------------------
byte readButtons(int pin) {
int b,c = 0;
  c=analogRead(pin);      // Lit lentree analogique 
    if (c>950) {
      lastBoutonNav=0;  // Remettre flag etat a zero
      return 0;           // Pas de bouton appuyé sortir
  }
  // Arrive ici normalement un bouton a ete appuye
  for (int i=1; i<10; i++) {
    MIDI.read();           // Lire midi pendant deboucing
    delay(1);              // Attente pour deboucong
  }
  
  c=analogRead(pin);      // Relire pour debouncing 
  if (c>950) {
      lastBoutonNav=0;  // Remettre flag etat a zero
      return 0;           // Toujours pas de bouton appuye
  }
 
  if (lastBoutonNav>0)   // Si le dernier bouton n'a pas ete relache
      return 9;   // renvoit code+10 (touche 1 = 11, 2=12, etc)
  // Arrivé ici on est sur que le bouton a ete appuye
  if (c>=0 && c<40) {
      lastBoutonNav=5;
      return 5;           // bouton 1 appuye
  } 
  if (c>70 && c<250) {
      lastBoutonNav=2;
      return 1;           // bouton 2 appuye
  } 
  if (c>250 && c<400) {
      lastBoutonNav=3;
      return 2;           // bouton 3 appuye
  }                       
  if (c>400 && c<600) {
        lastBoutonNav=4;
      return 3;           // bouton 4 appuye
  }
    if (c>600 ) {
        lastBoutonNav=5;
      return 4;           // bouton 4 appuye
  }
}

//----------------------------------------
// Affiche un octet en binaire
// Sert pour du debug
// A enlever une fois le programme termine
//----------------------------------------
void aff_binary(byte oct)
{
byte i;
    lcd.print(F("B"));
    for (i=8; i>0; i--) {
        if (bitRead(oct,i-1))
            lcd.print(F("1"));
        else
            lcd.print(F("0"));
    }
}

//--------------------------------------------------------
// Affiche une donne numerique avec des 0 non significatif
// nbdigits = longueur totale du nombre
//--------------------------------------------------------
void digitsLcd(byte valeur, byte x, byte y, byte nbdigits) {
  lcd.setCursor(x,y);
  MIDI.read();      
  if (nbdigits==3 && valeur <100)
      lcd.print(F("0"));
  MIDI.read();
  if (valeur<10)
      lcd.print(F("0"));
  MIDI.read();
  lcd.print(valeur,DEC);
  MIDI.read();
}

//--------------------------------------------------------
// Affiche "On" si valeur >0 sinon Off
// le tout a la position x,y
//--------------------------------------------------------
void OnOffLcd(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);      
  if (valeur)
      lcd.print(F("On "));
  else
      lcd.print(F("Off"));
}

//-----------------------------------------
// Affiche la forme d'onde de l'oscillateur
// le tout a la position x,y
//-----------------------------------------
void WaveLCD(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);
  switch(valeur) {
    case 0:
      lcd.print(F("OFF "));
      break;
    case 1:
      lcd.print(F("TRI "));
      break;
    case 2:
      lcd.print(F("SAW "));
      break;
    case 4:
      lcd.print(F("SQR "));
      break;
    case 8:
      lcd.print(F("NOIS"));
      break;
  }
}

//-----------------------------------------
// Affiche la forme d'onde des LFO
// le tout a la position x,y
//-----------------------------------------
void WaveLfoLCD(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);
  switch(valeur) {
    case 0:
      affChaineLcd("OFF ");
      break;
    case 1:
      affChaineLcd("SAW ");
      break;
    case 2:
      affChaineLcd("SAWr");
      break;
    case 3:
      affChaineLcd("SINE");
      break;
    case 4:
      affChaineLcd("TRI ");
      break;
    case 5:
      affChaineLcd("TRIr");
      break;           
    case 6:
      affChaineLcd("SQR ");
      break;           
  }
}

//-----------------------------------------
// Affiche la destination des LFO
// le tout a la position x,y
//-----------------------------------------
void DestLfoLCD(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);
  switch(valeur) {
    case 0:
      affChaineLcd("OFF ");
      break;
    case 1:
      affChaineLcd("PWM1");
      break;
    case 2:
      affChaineLcd("PWM2");
      break;
    case 3:
      affChaineLcd("PWM3");
      break;
    case 4:
      affChaineLcd("FIN1");
      break;
    case 5:
      affChaineLcd("FIN2");
      break;
    case 6:
      affChaineLcd("FIN3");
      break;
    case 7:
      affChaineLcd("CUT ");
      break;
    case 8:
      affChaineLcd("RES ");
      break;
  }
}





//---------------------------------------------------
// Affiche des chaines statiques sur le LCD
// on aurait pu utiliser lcd.print simplement
// mais cette procedure permet de lire le MIDI
// entre chaque caractere affiche, cela permet
// pendant un affichage important de reduire
// la latence.
// Les chaines sont en PROGMEM pour liberer de la RAM
//---------------------------------------------------
void affChaineLcdPROGMEM(byte item)
{
byte pos;
  memset(BuffAff,0,sizeof(BuffAff));
  // recopie item de la flash vers une chaine en RAM
  strcpy_P(BuffAff, (char*)pgm_read_word(&(MenuItem[item])));
  for (pos=0;pos<strlen(BuffAff);pos++) {
       lcd.print(BuffAff[pos]);
       MIDI.read();
  }
}



//---------------------------------------------------
// Affiche une chaine passee en parametre
// avec lecture du midi entre chaque caractere
// Identique au fonctionnement de affChaineLcdPROGMEM
// mais utilise la RAM
//---------------------------------------------------
void affChaineLcd(char *mychaine)
{
int i;
byte mychar;
char *p;
  p=mychaine;
  for (i=0;i<strlen(mychaine);i++,p++) {
     lcd.printByte(*p);
     MIDI.read();
  }
}

//-----------------------------------------------
// rafraichissement du LCD
// si parametre=9 rafraichit la page entière
// sinon, ne rafraichit que la partie dynamique.
// parametre modifié dans le menu(xm,ym)
//-----------------------------------------------
void aff_menu_LCD(byte parRaff)
{
  RPAGE=true;
  // Si rafraichissement total
  if (parRaff==9) {
    lcd.clear();          // Effacer tout lecran
    lcd.setCursor(0,0);   // Positionner en haut à gauche

    //----------------------------------------
    // AFFICHAGE PARTIE STATIQUE
    // uniquement affichee si rafLCD=9
    // Les fonds de pages ne sont pas affiches
    // pour d'autres valeurs de rafLCD
    //----------------------------------------
    switch (ym) {
      //---------------
      // Menus niveau 1
      //---------------
      case 0:
        switch(xm) {
          // sous menu oscillateur
          case 0:
          case 1:
          case 2:
            //"Synth>Oscillateur "
            affChaineLcdPROGMEM(0);
            lcd.print(xm+1,DEC);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            //"WAVE|PWM |SYNC|RING"
            affChaineLcdPROGMEM(2);
            break;
          // sous-menu filter freq
          case 3:
            //"Synth>Filter>Freq"
            affChaineLcdPROGMEM(3);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            //"FREQ|RES.|"            
            affChaineLcdPROGMEM(4);
            break;
          // sous-menu preset load
          case 5:
            // "Synth>Presets>Load"
            affChaineLcdPROGMEM(5);
            lcd.setCursor(0,2);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,3);
            // "P   |B   |     [OK]"
            affChaineLcdPROGMEM(18);
                      
            break;
          // sous-menu LFO1
          case 6:
            // "Synth>Presets>LFO1"
            affChaineLcdPROGMEM(19);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            // "Wave|Rate|Lev.|Dest"
            affChaineLcdPROGMEM(21);
                      
            break;
            
        }
        break;
      //---------------
      // Menus niveau 2  
      //---------------
      case 1:
        switch(xm) {
          // sous-menu enveloppe
          case 0:
          case 1:
          case 2:
            //"Synth>Enveloppe "
            affChaineLcdPROGMEM(8);  
            lcd.print(xm+1,DEC);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            // "ATTK|DECY|SUST|REL."
            affChaineLcdPROGMEM(9); 
            break;
          // sous-menu filter mode
          case 3:
            // "Synth>Filter>Modes"
            affChaineLcdPROGMEM(10);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(1,2);
            // "HP | BP | LP | OUT"
            affChaineLcdPROGMEM(11);
            break;
          // sous-menu preset Save  
          case 5:
            //"Synth>Presets>Save"
            affChaineLcdPROGMEM(12);
            lcd.setCursor(0,2);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,3);
            // "P   |B   |     [OK]"
            affChaineLcdPROGMEM(18);
            break;
          case 6:
            // "Synth>Presets>LFO2"
            affChaineLcdPROGMEM(20);
            lcd.setCursor(0,1);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            // "Wave|Rate|Lev.|Dest"
            affChaineLcdPROGMEM(21);
            break;            
        }
        break;
      //---------------
      // Menus niveau 3  
      //---------------
      case 2:
        switch(xm) {
          // sous-menu enveloppe
          case 0:
          case 1:
          case 2:
            //"Synth>Tuning "          
            affChaineLcdPROGMEM(13);
            lcd.print(xm+1,DEC);
            lcd.setCursor(0,1);
            affChaineLcdPROGMEM(1);
            lcd.setCursor(0,2);
            //"Cors|Fine|"
            affChaineLcdPROGMEM(14);
            break;
          // sous-menu filter routes
          case 3:
            //"Synth>Filter>Routes
            affChaineLcdPROGMEM(15);
            lcd.setCursor(0,1);
              affChaineLcdPROGMEM(1);
            lcd.setCursor(1,2);
            //"V1 | V2 | V3 | EXT"
            affChaineLcdPROGMEM(16);
            break;
          // sous-menu preset name (edition nom de preset)
          case 5:
            //"Synth>Presets>Name"
            affChaineLcdPROGMEM(17);
            lcd.setCursor(0,2);
            // SEP
            affChaineLcdPROGMEM(1);
            lcd.setCursor(1,3);
            lcd.printByte(CAR_LEFT);
            lcd.print(F("/"));
            lcd.printByte(CAR_RIGHT);
            MIDI.read();
            lcd.print(F("| "));
            lcd.printByte(CAR_UP);
            lcd.print(F("/"));
            lcd.printByte(CAR_DOWN);
            MIDI.read();
            lcd.print(F("|_0Aa|"));
            lcd.setCursor(17,3);
            //"OK"
            affChaineLcdPROGMEM(7);
            break;
        }

    }
    MIDI.read();
  }
  //------------------------------------
  // AFFICHAGE PARTIE DYNAMIQUE
  // Partie rafraichie dans tous les cas
  // quelque soit la valeur de rafLCD
  //------------------------------------
  switch (ym) {
    //----------------------------
    // Donnees dynamiques niveau 1
    //----------------------------
    case 0:
        switch(xm) {
        // sous menu oscillateur
        //----------------------
        case 0:
        case 1:
        case 2:
          // Precharger les donnees PWM et CTRL
          // en fonction de l'oscillateur selectionne
          if (xm==0) {
            myByte1=(pw1)>>4;   // Diviser par 16 PWM
            myByte2=ctrl1;
          }
          else {
            if (xm==1) {
            myByte1=(pw2)>>4;   // Diviser par 16 PWM
            myByte2=ctrl2;
            }
            else {
              myByte1=(pw3)>>4; // Diviser par 16 PWM
              myByte2=ctrl3;
            }
          }
          // PWM
          digitsLcd(myByte1,5,3,3);
          lcd.print(F(" |"));
          MIDI.read();
          // SYNC
          OnOffLcd(bitRead(myByte2,1),11,3);
          lcd.print(F("|"));
          MIDI.read();
          // RING
          OnOffLcd(bitRead(myByte2,2),16,3);
            MIDI.read();
          // Forme onde
          myByte2=myByte2>>4;   // decaler pour recuperer les donnees waves
          WaveLCD(myByte2,0,3);
          lcd.print(F("|"));
          MIDI.read();
          break;
        // sous-menu filter freq
        //----------------------
        case 3:
          // Frequence
          myWord1=(freq>>4);
          digitsLcd(myWord1,0,3,3);
          lcd.print(F(" |"));
          MIDI.read();
          // resonance
          myByte1=(res>>4);
          digitsLcd(myByte1,6,3,2);
          lcd.print(F(" |"));
          MIDI.read();
          break;
        // sous-menu preset load
        //----------------------
        case 5:
          lcd.setCursor(0,1);
          lcd.print(F(">>"));
          load_preset_name(noBanque,noPreset);
          affChaineLcd(nomPreset);
          
//          lcd.print(nomPreset);
          lcd.print(F("<<"));
          digitsLcd(noPreset+1,1,3,3);
          MIDI.read();
          digitsLcd(noBanque+1,6,3,3);
          break;
        // sous-menu preset load
        //----------------------
        case 6:
          WaveLfoLCD(Lfo1Wave,0,3);
          lcd.print(F("|"));
          digitsLcd(Lfo1Speed,6,3,3);
          lcd.print(F("|"));
          MIDI.read();
          digitsLcd(Lfo1Level,11,3,3);
          lcd.print(F("|"));
          DestLfoLCD(Lfo1Dest,15,3);
          break;
          
          
      }
      break;
    //----------------------------
    // Donnees dynamiques niveau 2
    //----------------------------
    case 1:
      lcd.setCursor(0,0);
      switch(xm) {
        // sous-menu enveloppe
        //--------------------
        case 0:
        case 1:
        case 2:
          // Chargement des valeurs ad et sr
          // en fonction du menu oscillateur actif
          if (xm==0) {
            myByte1=ad1;
            myByte2=sr1;
          }
          else {
            if (xm==1) {
              myByte1=ad2;
              myByte2=sr2;
            }
            else {
              myByte1=ad3;
              myByte2=sr3;
            }
          }
          // Affiche Attaque        
          digitsLcd(myByte1>>4,1,3,2);
          lcd.print(F(" |"));
          MIDI.read();
          // affiche Decay
          digitsLcd((myByte1 & 0x0F),6,3,2);
          lcd.print(F(" |"));
          MIDI.read();
          // Affiche Sustain
          digitsLcd(myByte2>>4,11,3,2);
          lcd.print(F(" |"));
          MIDI.read();
          // Affiche Release
          digitsLcd((myByte2 & 0x0F),16,3,2);
          MIDI.read();
          break;
        // sous-menu filter mode
        //----------------------
        case 3:
          lcd.setCursor(0,3);
          // Filtre HP
          OnOffLcd(bitRead(mode,6),1,3);
          lcd.print(F("|"));
          MIDI.read();
          // Filtre BP
          OnOffLcd(bitRead(mode,5),6,3);
          lcd.print(F("|"));
          MIDI.read();
          // Filtre LP
          OnOffLcd(bitRead(mode,4),11,3);
          lcd.print(F("|"));
          MIDI.read();
          // Volume OUT
          //myByte1=mode & 0x0F;
          //digitsLcd(myByte1,16,3,2);
          digitsLcd((mode & 0x0F),16,3,2);
          MIDI.read();
          break;
        // sous-menu preset Save  
        case 5:
          lcd.setCursor(0,1);
          lcd.print(F(">>"));
          load_preset_name(noBanque,noPreset);
          //lcd.print(nomPreset);
          affChaineLcd(nomPreset);
          lcd.print(F("<<"));
          digitsLcd(noPreset+1,1,3,3);
          MIDI.read();
          digitsLcd(noBanque+1,6,3,3);
          break;
        // sous-menu lfo 2
        //----------------
        case 6:
          WaveLfoLCD(Lfo2Wave,0,3);
          lcd.print(F("|"));
          digitsLcd(Lfo2Speed,6,3,3);
          lcd.print(F("|"));
          MIDI.read();
          digitsLcd(Lfo2Level,11,3,3);
          lcd.print(F("|"));
          DestLfoLCD(Lfo2Dest,15,3);
          break;
      }
      break;
    //----------------------------
    // Donnees dynamiques niveau 3
    //----------------------------
    case 2:
      lcd.setCursor(0,0);
      switch(xm) {
        // sous-menu tuning (Coarse et Fine)
        case 0:
        case 1:
        case 2:
          // Precharger les donnees COARSE et FINE
          // en fonction de l'oscillateur selectionne
          if (xm==0) {
            myInt=coarse1-16;
            myByte1=fine1;
          }
          else {
            if (xm==1) {
              myInt=coarse2-16;
              myByte1=fine2;
            }
            else {
              myInt=coarse3-16;
              myByte1=fine3;
            }
          }
          // Afficher la valeur coarse
          // elle est decalee de -16
          // donc 0 a l'ecran correspond a coarse=16 
          lcd.setCursor(0,3);
          // Tester si coarse negatif ( si <16, l'entier myInt est negatif)
          // Si oui, afficher le signe "-" et rendre positif la valeur 
          // on aurait pu afficher l'entier directement mais ceci a ete fait
          // afin d'afficher les donnees justifiee et ne pas utiliser sprintf      
          if (myInt<0) {
            myInt*=-1;
            lcd.print(F("-"));
          }
          else {
            lcd.print(F(" "));
          }
          digitsLcd((byte)myInt,1,3,2);
          lcd.print(F(" |"));
          MIDI.read();
         
          // Afficher la valeur fine
          // varie de 0 a 127
          digitsLcd(myByte1,5,3,3);
          lcd.print(F(" |"));
          MIDI.read();
          break;
        // sous-menu filter routes
        case 3:
          // Affiche routage filtre
          // en fonction du contenu de res
          
          // Voice 1 -> Filtre
          OnOffLcd(bitRead(res,0),1,3);
          lcd.print(F("|"));
          MIDI.read();
          // Voice 2 -> Filtre
          OnOffLcd(bitRead(res,1),6,3);
          lcd.print(F("|"));
          MIDI.read();
          // Voice 3 -> Filtre
          OnOffLcd(bitRead(res,2),11,3);
          lcd.print(F("|"));
          MIDI.read();
          // External -> Filtre
          OnOffLcd(bitRead(res,3),16,3);
          MIDI.read();
          break;
        // sous-menu preset name (edition nom de preset)
        case 5:
          lcd.setCursor(0,1);
          // Afficher le nom de preset en cours
          lcd.print(F(">>"));
          load_preset_name(noBanque,noPreset);
          affChaineLcd(nomPreset);
          //lcd.print(nomPreset);
          lcd.print(F("<<"));
          posCarPreset=2;                 // position x premier caractere
          lcd.setCursor(posCarPreset,1);  // positionner le curseur
          lcd.cursor();                   // Affiche le curseur
          //lcd.blink();                    // Curseur clignotant        
          break;
      }
  }
  RPAGE=false;  
}

//--------------------------------------------------
// Gestion des menus partie edition SID
// valeur du bouton courant dans valbouton en global
//--------------------------------------------------
void gestionBoutonsSid(void){
  switch(valbouton) {
    case B_MAINT:           // Bouton maintenu appuye
      return;               // rien a faire pour l'instant
      break;
    // Menus OSC1, Env1, Tuning1
    case B_F1:
      xm=MENUOSC1;          // menu courant =  OSC1
      break;
    // Menus OSC2, Env2, Tuning2
    case B_F2:              
      xm=MENUOSC2;          // menu courant =  OSC2
      break;
    // Menus OSC3, Env3, Tuning3
    case B_F3:
      xm=MENUOSC3;          // menu courant =  OSC3
      break;
    // Menus filter>Freq, filter>Mode, filter>routes
    case B_F4:
      xm=MENUFILTER;        // menu courant =  Filtre
      break;
    // Changement mode (SID ou preset)
    case B_F5:
      xm=MENUPRESETS;
      lxm=xm;
      modeMenu=EDITPRESETS;
      ym=0;
      rafLCD=9;           // Rafraichir LCD changement de mode
      return;             // on s'en va, changement de mode
      break;
  }
  // Arrive ici, une touche autre que F5 ou MAINT a ete appuyee
  // il faut recalculer la position
  // et rafrachir completement le menu
  if (lxm==xm) {          // Si on reste dans meme arborescence
      
      if (++ym >2) {     // Incrementer sous menu (3 niveau max)
          ym=0;           // remettre a zero si on a fait le tour
      }
  }
  else {                  // si on a change d'arborescence
      lxm=xm;             // on memorise le changement de menu
      ym=0;               // le sous-menu passe a zero
  }
  rafLCD=9;              // on force le rafraichissement complet
}

//--------------------------------------------------
// Gestion des menus partie edition des presets
// valeur du bouton courant dans valbouton en global
//--------------------------------------------------
void gestionBoutonsPresets(void) {
  switch(valbouton) {
    case B_MAINT:           // Bouton maintenu appuye
      return;
      break;
    case B_F1:
      xm=MENUPRESETS;
      break;
    case B_F2:
      xm=MENULFO;
               
      break;
    case B_F3:
      return;
      break;
    // validation
    // de SAVE, LOAD ou change NAME  
    case B_F4:
      if (xm!=MENUPRESETS)
        return;
      // Si contexte de load
      if (ym==0) {
        // Charge le preset et initialise le SID
        load_preset(noBanque,noPreset);
        // rester sur le menu load 
        return;              
      }
      // Si contexte de save
      if (ym==1) {
          // On passe sur le menu de selection du nom
          // Le fait d'avoir valider avec OK valide le fait
          // qu'on va sauvegarder. On passe ensuite a la modification
          // du nom de preset avec le contexte ym=2
          ym=2;           // Contexte selection nom de sauvegarde
          posCarPreset=2; // Mettre a zero la position du curseur
          rafLCD=9;       // rafraichissement complet
          return;         // sortie pour changement de contexte
      }
      if (ym==2) {
        // Supprimer curseur et clignotement
        //lcd.noBlink();  // arret clignotement curseur
        lcd.noCursor(); // supression du curseur
        save_preset(noBanque,noPreset);
        ym=0;           // revenir contexte load
        rafLCD=9;
        return;
      }
      break;
    case B_F5:
      xm=MENUOSC1;
      lxm=xm;
      modeMenu=EDITSID;
      ym=0;
      rafLCD=9;           // Rafraichir LCD changement de mode
      return;
      break;
  }
  // Arrive ici, une touche autre que F5 ou MAINT a ete appuyee
  // il faut recalculer la position
  // et rafrachir completement le menu
  if (lxm==xm) {          // Si on reste dans meme arborescence
      if (++ym >1) {     // Incrementer sous menu (2 niveau max)
          ym=0;           // remettre a zero si on a fait le tour
      }
  }
  else {                  // si on a change d'arborescence
      lxm=xm;             // on memorise le changement de menu
      ym=0;               // le sous-menu passe a zero
  }
  rafLCD=9;              // on force le rafraichissement complet
}

//---------------------------------------------------------------
// Envoie la valeur 'ValCC' respectivement sur un des controleurs
// cc1, cc2 ou cc3 en fonction de la valeur contexte
// la valeur de contexte est définie par xm
//---------------------------------------------------------------
void SendContextCC(byte context, byte cc1, byte cc2, byte cc3, byte ValCC)
{
  switch(context) {
    case 0:
     DoHandleControlChange (1, cc1, ValCC);
     break;
    case 1:
     DoHandleControlChange (1, cc2, ValCC);
     break;
    case 2:
     DoHandleControlChange (1, cc3, ValCC);
     break;
  }
}

//------------------------------------------------
// Gestion des 3 oscillateurs
// xm permet de connaitre l'oscillateur a modifier
// gere WAVE, PWM, SYNC et RING
//------------------------------------------------
void gestionEncOscillateur(void)
{
  // Chargement des valeurs DUTY, WAVE, SYNC, RING
  // en fonction du menu oscillateur actif
  if (xm==0) {
    myByte1=pw1>>4;
    myByte2=ctrl1;
  }
  else {
    if (xm==1) {
      myByte1=pw2>>4;
      myByte2=ctrl2;
    }
    else {
      myByte1=pw3>>4;
      myByte2=ctrl3;
    }
  }
  switch(valencodeurs) {
      // Wave Down (NOISE->SQUARE->SAW>TRI->OFF)
      case ENC1DOWN:
        myByte2=myByte2>>4;
        if (myByte2>0) {
          // decalage dun bit a droite pour changer de forme d'onde
          myByte2=myByte2>>1;
          // Reformater myByte2 pour les CC
          if (myByte2==1) myByte2=16;
          if (myByte2==2) myByte2=32;
          if (myByte2==4) myByte2=48;
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_WAVE1,CC_WAVE2,CC_WAVE3,byte(myByte2));
        }
        break;
      // Wave Up (OFF->TRI->SAW->SQUARE->NOISE)
      case ENC1UP:
        myByte2=myByte2>>4;
        if (myByte2<8) {
          if (myByte2==0)
            myByte2=1;
          else
            myByte2=myByte2<<1;
          // Reformater myByte2 pour les CC
          if (myByte2==1) myByte2=16;  
          if (myByte2==2) myByte2=32;
          if (myByte2==4) myByte2=48;
          if (myByte2==8) myByte2=64;
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_WAVE1,CC_WAVE2,CC_WAVE3,byte(myByte2));
        }
        break;
  
  
      // PWM Down
      case ENC2DOWN:
        if (myByte1>1) {
          --myByte1;
          SendContextCC(xm,CC_DUTY1,CC_DUTY2,CC_DUTY3,byte(myByte1));
          }
        break;
      // PWM UP
      case ENC2UP:
        if (myByte1<255) {
          ++myByte1;
          SendContextCC(xm,CC_DUTY1,CC_DUTY2,CC_DUTY3,byte(myByte1));
        }
        break;
      // SYNC Off
      case ENC3DOWN:
        if (bitRead(myByte2,1)) {
          SendContextCC(xm,CC_SYNC1,CC_SYNC2,CC_SYNC3,byte(0));
        }                   
        break;
      // SYNC On
      case ENC3UP:
        if (!bitRead(myByte2,1)) {
          SendContextCC(xm,CC_SYNC1,CC_SYNC2,CC_SYNC3,byte(64));
        }                   
        break;
      // Ring On
      case ENC4DOWN:
        // Tester bit 2
        if (bitRead(myByte2,2)) {
          SendContextCC(xm,CC_RING1,CC_RING2,CC_RING3,byte(0));
        }                   
        break;
      // Ring Off
      case ENC4UP:
        if (!bitRead(myByte2,2)) {
          SendContextCC(xm,CC_RING1,CC_RING2,CC_RING3,byte(64));
        }                   
        break;
  }
  
}

//----------------------------------------------
// Gestion des 3 enveloppes ADSR
// xm permet de connaitre l'enveloppe a modifier
// gere attack, decay, sustain, release
//----------------------------------------------
void gestionEncEnveloppe(void)
{
  // Chargement des valeurs ad et sr
  // en fonction du menu oscillateur actif
  if (xm==0) {
    myByte1=ad1;
    myByte2=sr1;
  }
  else {
    if (xm==1) {
    myByte1=ad2;
    myByte2=sr2;
    }
    else {
    myByte1=ad3;
    myByte2=sr3;
    }
  }
  switch(valencodeurs) {
      // Attaque Down 
      case ENC1DOWN:
        myByte1=(myByte1>>4);
        if (myByte1>0) {
          --myByte1;
          myByte1=(myByte1<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_ATTACK1,CC_ATTACK2,CC_ATTACK3,byte(myByte1));
        }
        break;
      // Attaque UP 
      case ENC1UP:
        myByte1=(myByte1>>4);
        if (myByte1<15) {
          ++myByte1;
          myByte1=(myByte1<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_ATTACK1,CC_ATTACK2,CC_ATTACK3,byte(myByte1));
        }
        break;
      // Decay Down 
      case ENC2DOWN:
        // pour le decay ne garder que les 4 premiers bits
        myByte1 &= 0x0F;
        if (myByte1>0) {
          --myByte1;
          myByte1=(myByte1<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_DECAY1,CC_DECAY2,CC_DECAY3,byte(myByte1));
        }
        break;
      // Decay UP 
      case ENC2UP:
        // pour le decay ne garder que les 4 premiers bits
        myByte1 &= 0x0F;
        if (myByte1<15) {
          ++myByte1;
          myByte1=(myByte1<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_DECAY1,CC_DECAY2,CC_DECAY3,byte(myByte1));
        }
        break;
        
      // Sustain Down 
      case ENC3DOWN:
        myByte2=(myByte2>>4);
        if (myByte2>0) {
          --myByte2;
          myByte2=(myByte2<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_SUSTAIN1,CC_SUSTAIN2,CC_SUSTAIN3,byte(myByte2));
        }
        break;
      // Sustain UP 
      case ENC3UP:
        myByte2=(myByte2>>4);
        if (myByte2<15) {
          ++myByte2;
          myByte2=(myByte2<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_SUSTAIN1,CC_SUSTAIN2,CC_SUSTAIN3,byte(myByte2));
        }
        break;
      // Release Down 
      case ENC4DOWN:
        // pour le release ne garder que les 4 premiers bits
        myByte2 &= 0x0F;
        if (myByte2>0) {
          --myByte2;
          myByte2=(myByte2<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_RELEASE1,CC_RELEASE2,CC_RELEASE3,byte(myByte2));
        }
        break;
      // Release UP 
      case ENC4UP:
        // pour le release ne garder que les 4 premiers bits
        myByte2 &= 0x0F;
        if (myByte2<15) {
          ++myByte2;
          myByte2=(myByte2<<3);
          // Mettre a jour les donnees dans le SID
          SendContextCC(xm,CC_RELEASE1,CC_RELEASE2,CC_RELEASE3,byte(myByte2));
        }
        break;
  }
}

//------------------------------------------------
// Gestion des 3 tunings oscillateur
// xm permet de connaitre l'oscillateur a modifier
// gere tuning coarse et tuning fine
//------------------------------------------------
void gestionEncTuning(void)
{
  // Precharger les donnees COARSE et FINE
  // en fonction de l'oscillateur selectionne
  if (xm==0) {
    myInt=coarse1-16;
    myByte1=fine1;
  }
  else {
    if (xm==1) {
    myInt=coarse2-16;
    myByte1=fine2;
    }
    else {
    myInt=coarse3-16;
    myByte1=fine3;
    }
  }
  
  switch(valencodeurs) {
    // Coarse Down
    case ENC1DOWN:
      if (myInt>-16) {
        --myInt;
        myByte1=(byte)(myInt+16);
        myByte1=(myByte1<<2);
        // Mettre a jour les donnees dans le SID
        SendContextCC(xm,CC_COARSE1,CC_COARSE2,CC_COARSE3,byte(myByte1));
      }
      break;
    // Coarse UP
    case ENC1UP:
      if (myInt<15) {
        ++myInt;
        myByte1=(byte)(myInt+16);
        myByte1=(myByte1<<2);
        // Mettre a jour les donnees dans le SID
        SendContextCC(xm,CC_COARSE1,CC_COARSE2,CC_COARSE3,byte(myByte1));
      }
      break;
    // Fine Down
    case ENC2DOWN:
      if (myByte1>0) {
        --myByte1;
        // Mettre a jour les donnees dans le SID
        SendContextCC(xm,CC_FINE1,CC_FINE2,CC_FINE3,byte(myByte1));
      }
      break;
    // Fine UP
    case ENC2UP:
      if (myByte1<127) {
        ++myByte1;
        // Mettre a jour les donnees dans le SID
        SendContextCC(xm,CC_FINE1,CC_FINE2,CC_FINE3,byte(myByte1));
      }
      break;
  }
}



//----------------------------------
// Gestion du filtre
// Gere la frequence et la resonance
//----------------------------------
void gestionEncFiltreFreq(void)
{
  myWord1=0;
  myByte1=0;
  switch(valencodeurs) {
      case ENC1DOWN:
        myWord1=(freq>>4);
        if (myWord1>0) {
          --myWord1;
          DoHandleControlChange (1, CC_CUT, byte(myWord1));
        }
        break;
      case ENC1UP:
        myWord1=(freq>>4);
        if (myWord1<127) {
          ++myWord1;
          DoHandleControlChange (1, CC_CUT, byte(myWord1));
        }
        break;
      case ENC2DOWN:
        myByte1=(res>>4);
        if (myByte1>0) {
          --myByte1;
          myByte1=(myByte1<<3);
          DoHandleControlChange (1, CC_RES, byte(myByte1));
        }
        break;
      case ENC2UP:
        myByte1=(res>>4);
        if (myByte1<15) {
          ++myByte1;
          myByte1=(myByte1<<3);
          DoHandleControlChange (1, CC_RES, byte(myByte1));
        }
        break;
  }
}

//---------------------------------
// Gestion des modes du filtre
// Gere modes HP,BP,LP en On ou Off
// Gere le volume global du SID
//---------------------------------
void gestionEncFiltreMode(void)
{
  myWord1=0;
  myByte1=0;
  switch(valencodeurs) {
      // Filtre HP Off
      case ENC1DOWN:
        if (bitRead(mode,6)) {
             DoHandleControlChange (1, CC_HP, byte(0));
        }                   
        break;
      // Filtre HP On
      case ENC1UP:
        if (!bitRead(mode,6)) {
             DoHandleControlChange (1, CC_HP, byte(64));
        }                   
        break;
      // Filtre BP Off

      case ENC2DOWN:
        if (bitRead(mode,5)) {
             DoHandleControlChange (1, CC_BP, byte(0));
        }                   
        break;
      // Filtre BP On
      case ENC2UP:
        if (!bitRead(mode,5)) {
             DoHandleControlChange (1, CC_BP, byte(64));
        }                   
        break;

      // Filtre LP Off
      case ENC3DOWN:
        if (bitRead(mode,4)) {
             DoHandleControlChange (1, CC_LP, byte(0));
        }                   
        break;
      // Filtre LP On
      case ENC3UP:
        if (!bitRead(mode,4)) {
             DoHandleControlChange (1, CC_LP, byte(64));
        }                   
        break;

      // Volume de sortie DOWN
      case ENC4DOWN:
        myByte1=mode & 0x0F;
        if (myByte1>0) {
          --myByte1;
          myByte1=(myByte1<<3);
          DoHandleControlChange (1, CC_MASTER, byte(myByte1));
        }
        break;
      // Volume de sortie UP
      case ENC4UP:
        myByte1=mode & 0x0F;
        if (myByte1<15) {
          ++myByte1;
          myByte1=(myByte1<<3);
          DoHandleControlChange (1, CC_MASTER, byte(myByte1));
        }
        break;
  }
}

//---------------------------------------------
// Gestion du routage vers le filtre
// gere le passage de chaque OSC dans le filtre
// gere le passage entree EXT dans le filtre
//---------------------------------------------
void gestionEncFiltreRoutes(void)
{
  myWord1=0;
  myByte1=0;
  switch(valencodeurs) {
      // Voix 1 vers filtre
      case ENC1DOWN:
        if (bitRead(res,0)) {
             DoHandleControlChange (1, CC_OUT1, byte(0));
        }                   
        break;
      case ENC1UP:
        if (!bitRead(res,0)) {
             DoHandleControlChange (1, CC_OUT1, byte(64));
        }                   
        break;
      // Voix 2 vers filtre
      case ENC2DOWN:
        if (bitRead(res,1)) {
             DoHandleControlChange (1, CC_OUT2, byte(0));
        }                   
        break;
      case ENC2UP:
        if (!bitRead(res,1)) {
             DoHandleControlChange (1, CC_OUT2, byte(64));
        }                   
        break;
      // Voix 3 vers filtre
      case ENC3DOWN:
        if (bitRead(res,2)) {
             DoHandleControlChange (1, CC_OUT3, byte(0));
        }                   
        break;
      case ENC3UP:
        if (!bitRead(res,2)) {
             DoHandleControlChange (1, CC_OUT3, byte(64));
        }                   
        break;
      // Externe vers filtre
      // Non gere pour l'instant sur le shield SIDaster en v4
      case ENC4DOWN:
        if (bitRead(res,3)) {
             DoHandleControlChange (1, CC_INPUT, byte(0));
        }                   
        break;
      case ENC4UP:
        if (!bitRead(res,3)) {
            DoHandleControlChange (1, CC_INPUT, byte(64));
        }                   
        break;
  }
}



// ---------------------------------
// Gestion des donnees SID
// Utilise le dernier encodeur bouge
// programme le parametre adequat en
// fonction du sous-menu actif
// ---------------------------------
void gestionDonneesSid(void)
{
  switch(xm) {
    // Gestion OSC, ADSR, TUNING
    case 0:
    case 1:
    case 2:  
      switch(ym) {
        case 0:
          gestionEncOscillateur();
          break;
        case 1:
          gestionEncEnveloppe();
          break;
        case 2:
          gestionEncTuning();
          break;
      }
      break;
    // Gestion FILTRE
    case 3:
      switch(ym) {
        case 0:
          gestionEncFiltreFreq();
          break;
        case 1:
          gestionEncFiltreMode();
          break;
        case 2:
          gestionEncFiltreRoutes();
          break;
      }
      break;      
      
  }
}

//----------------------------------------------
// Gestion chargement des presets
// Selection de la banque et du numero de preset
//----------------------------------------------
void gestionEncPresetsLoad(void)
{
boolean affpreset;
  affpreset=false;
  switch(valencodeurs) {
      // Preset down
      case ENC1DOWN:
        if (noPreset) {
          noPreset--;
          affpreset=true;
        }  
        break;
      // Preset UP
      case ENC1UP:
        if (noPreset<127) {
          noPreset++;
          affpreset=true;
        }                   
        break;
      // Banque Down
      case ENC2DOWN:
        if (noBanque) {
            noBanque--;
            affpreset=true;
        }                   
        break;
      // Banque UP
      case ENC2UP:
        if (noBanque<MAXBANK-1) {
             noBanque++;
             affpreset=true;
        }                   
        break;
  }
  if (affpreset) { 
      lcd.setCursor(0,1);
      lcd.print(F(">>"));
      load_preset_name(noBanque,noPreset);
      affChaineLcd(nomPreset);
      //lcd.print(nomPreset);
      lcd.print(F("<<"));
      digitsLcd(noPreset+1,1,3,3);
      MIDI.read();
      digitsLcd(noBanque,6,3,3);
  }
}

//-------------------------------------
// Gestion sauvegarde du preset
// Selection du preset et de la banque
// et sauvegarde des variables globales
// dans ce preset
//-------------------------------------
void gestionEncPresetsSave(void)
{
boolean affpreset;
  affpreset=false;
  switch(valencodeurs) {
      // Preset down
      case ENC1DOWN:
        if (noPreset) {
          noPreset--;
          affpreset=true;
        }  
        break;
      // Preset UP
      case ENC1UP:
        if (noPreset<127) {
          noPreset++;
          affpreset=true;
        }                   
        break;
      // Banque Down
      case ENC2DOWN:
        if (noBanque) {
            noBanque--;
            affpreset=true;
        }                   
        break;
      // Banque UP
      case ENC2UP:
        if (noBanque<MAXBANK-1) {
             noBanque++;
             affpreset=true;
        }                   
        break;
  }
  if (affpreset) {
      lcd.setCursor(0,1);
      lcd.print(F(">>"));
      load_preset_name(noBanque,noPreset);
      affChaineLcd(nomPreset);
      //lcd.print(nomPreset);
      lcd.print(F("<<"));
      digitsLcd(noPreset+1,1,3,3);
      MIDI.read();
      digitsLcd(noBanque,6,3,3);
  }
}

//----------------------------------
// Gestion edition dun nom de preset
// avant la sauvegarde
// Jeu de caractere utilisee :
// [Space]()*+-./0123456789
// ABCDEFGHIJKLMNOPQRSTUVWXYZ
// abcdefghijklmnopqrstuvwxyz
//----------------------------------
void gestionEncPresetsName(void)
{
boolean affchar;
char mychar;
  affchar=false;
  switch(valencodeurs) {
        
      // caractere vers la gauche
      case ENC1DOWN:
        if (posCarPreset>2) {     // x=2 sur le premier caractere
          posCarPreset--;         // decrementer la position en x
          affchar=true;
        }
        break;
      // caractere vers la droite
      case ENC1UP:
        if (posCarPreset<17) {    // x=18 sur le dernier caractere
          posCarPreset++;         // Incrementer la position en x
          affchar=true;
        }
        break;
      // Changement du caractere courant
      // prendre le precedent dans le jeu
      // fait le tour complet
      case ENC2DOWN:
        mychar=nomPreset[posCarPreset-2];   // Recuperer le caractere courant
        switch(mychar) {
          case ' ':
            mychar='z';
            break;
          case 'a':
            mychar='Z';
            break;
          case 'A':
            mychar='9'; 
            break;
          case '-':
            mychar='+'; 
            break;
          case '(':
            mychar=' '; 
            break;
          default:
            mychar--;
            break;
        }                   
        nomPreset[posCarPreset-2]=mychar;     // Rafraichir nouveau caractere
        affchar=true;                         // Forcer l'affichage
        break;
      // Changement du caractere courant
      // prendre le suivant dans le jeu
      // fait le tour complet
      case ENC2UP:
        mychar=nomPreset[posCarPreset-2];   // Recuperer le caractere courant
        switch(mychar) {
          case ' ':
            mychar='(';
            break;
          case '+':
            mychar='-'; 
            break;
          case '9':
            mychar='A'; 
            break;
          case 'Z':
            mychar='a'; 
            break;
          case 'z':
            mychar=' ';
            break;
          default:
            mychar++;
            break;
        }                   
        nomPreset[posCarPreset-2]=mychar;     // Rafraichir nouveau caractere
        affchar=true;                         // Forcer l'affichage
        break;
        
      // Fait des sauts par type de caractere
      // [a..z],[A..Z],[0-9],[Space]
      case ENC3DOWN:
        mychar=nomPreset[posCarPreset-2];   // Recuperer le caractere courant
        if (mychar>'a') {
          mychar='a';
        }
        else {
          if (mychar >'A' && mychar<='a' ) {
            mychar='A';
          }
          else {
            if (mychar >'0' && mychar<='A' ) {
              mychar='0';
            }
            else {
              if (mychar <='0')
                mychar=' ';
            }
          }
        }
        nomPreset[posCarPreset-2]=mychar;     // Rafraichir nouveau caractere
        affchar=true;                         // Forcer l'affichage
        break;
        
      // Fait des sauts par type de caractere
      // [Space],[0-9],[A..Z],[a..z]
      case ENC3UP:
        mychar=nomPreset[posCarPreset-2];   // Recuperer le caractere courant
        if (mychar<'0') {
          mychar='0';
        }
        else {
          if (mychar>='0' && mychar<'A') {
            mychar='A';
          }
          else {
            if (mychar >='A' && mychar<'a' ) {
                mychar='a';
            }   
          }
        }
        nomPreset[posCarPreset-2]=mychar;     // Rafraichir nouveau caractere
        affchar=true;                         // Forcer l'affichage
        break;
        
  }
  if (affchar) {
      lcd.noCursor(); 
      lcd.setCursor(posCarPreset,1);        // Positionner le curseur
      lcd.print(nomPreset[posCarPreset-2]); // posCarPreset - 2 pour indicer
      lcd.setCursor(posCarPreset,1);        // repositionner le curseur
      lcd.cursor();
      MIDI.read();
  }
}



// ---------------------------------
// Gestion des donnees presets
// Utilise le dernier encodeur bouge
// programme le parametre adequat en
// fonction du sous-menu actif
// ---------------------------------
void gestionDonneesPresets(void)
{
  switch(xm) {
    case 5 :  
      switch(ym) {
        case 0:
          gestionEncPresetsLoad();
          break;
        case 1:
          gestionEncPresetsSave();
          break;
        case 2:
          gestionEncPresetsName();
          break;
      }
      break;
    case 6 :  
      switch(ym) {
        case 0:
          gestionEncLfo1();
          break;
        case 1:
          gestionEncLfo2();
          break;
      }
      break;
  }
}



//------------------------------------------------
// Lecture des boutons et changement de menu
// lecture des encodeurs et changement des valeurs
// demande rafraichissement du LCD
//------------------------------------------------
void gestion_menu_principal(void)
{
  // Lire la valeur du bouton
  valbouton=readButtons(PINBNAV);
  MIDI.read();
  rafLCD=0;
  
  
  // Si un bouton appuye
  // Gerer en fonction du mode SID ou preset
  if (valbouton!=0) {
      if (modeMenu==EDITSID) {
          gestionBoutonsSid();
      }
      else { 
          if (modeMenu==EDITPRESETS)
              gestionBoutonsPresets();
      }
  }
  
  // Lire les encodeurs
  valencodeurs=readEncodeurs();
  MIDI.read();

  // Si un encodeur a bougé
  // traiter la donnees
  if (valencodeurs) {
      if (modeMenu==EDITSID) {
          gestionDonneesSid();
      }
      else { 
        if (modeMenu==EDITPRESETS)
          gestionDonneesPresets();
      }
  }
  MIDI.read();
  // Si changement de donnees par utilisateur
  // rafraichir LCD
  if (rafLCD) {         // Si flag affichage
    aff_menu_LCD(rafLCD);  // Rafraichir menu controleur
    rafLCD=0;
  }
}

//-----------------------------------
// reset de la precedente destination
//-----------------------------------
void ResetLfoDest(byte numdest)
{
  switch(numdest) {
    // Si destination PWM1
    case 1 :
      DoHandleControlChange (1,CC_DUTY1,pw1>>4);
      break;
    case 2:
      // Si destination PWM2
      DoHandleControlChange (1,CC_DUTY2,pw2>>4);
      break;
    case 3:
      // Si destination PWM3
      DoHandleControlChange (1,CC_DUTY3,pw3>>4);
      break;
    case 4:
      // Si destination FINE1
      DoHandleControlChange (1,CC_FINE1,fine1);
      break;
    case 5:
      // Si destination FINE2
      DoHandleControlChange (1,CC_FINE2,fine2);
      break;
    case 6:
      // Si destination FINE3
      DoHandleControlChange (1,CC_FINE3,fine3);
      break;
    case 7:
      // Si destination CUT
      DoHandleControlChange (1,CC_CUT,freq>>4);
      break;
    case 8:
      myByte1=res>>4;
      myByte1=myByte1<<3;
      // Si destination CUT
      DoHandleControlChange (1,CC_RES,myByte1);

      
      break;
  }
}

//-----------------------------------------------
// Gestion encodeur lfo1
// regle forme onde, vitesse, niveau, destination
//-----------------------------------------------
void gestionEncLfo1(void)
{
  switch(valencodeurs) {
      // Wave Down
      case ENC1DOWN:
        if (Lfo1Wave) {
            Lfo1Val=0;
            Lfo1Pos=0;
            ResetLfoDest(Lfo1Dest);
            Lfo1Wave--;
            WaveLfoLCD(Lfo1Wave,0,3);
        }
        break;
      // Wave UP
      case ENC1UP:
        if (Lfo1Wave<6) {
            Lfo1Val=0;
            Lfo1Pos=0;
            ResetLfoDest(Lfo1Dest);
            Lfo1Wave++;
            WaveLfoLCD(Lfo1Wave,0,3);
        }
        break;
      // Rate Down
      case ENC2DOWN:
        if (Lfo1Speed>1) {
            Lfo1Speed--;
            digitsLcd(Lfo1Speed,6,3,3);
            Lfo1Prescaler=255-Lfo1Speed*2;
        }
        break;
      // Rate UP
      case ENC2UP:
        if (Lfo1Speed<127) {
            Lfo1Speed++;
            digitsLcd(Lfo1Speed,6,3,3);
            Lfo1Prescaler=255-Lfo1Speed*2;
        }
        break;
      // Level Down
      case ENC3DOWN:
        if (Lfo1Level>1) {
            Lfo1Level--;
            digitsLcd(Lfo1Level,11,3,3);
        }
        break;
      // Level UP
      case ENC3UP:
        if (Lfo1Level<127) {
            Lfo1Level++;
            digitsLcd(Lfo1Level,11,3,3);
        }
        break;
      // Destination Down
      case ENC4DOWN:
        if (Lfo1Dest>0) {
            Lfo1Val=0;
            Lfo1Pos=0;
            ResetLfoDest(Lfo1Dest);
            Lfo1Dest--;
            DestLfoLCD(Lfo1Dest,15,3);
        }
        break;
      // Destination UP
      case ENC4UP:
        if (Lfo1Dest<8) {
            Lfo1Val=0;
            Lfo1Pos=0;
            ResetLfoDest(Lfo1Dest);
            Lfo1Dest++;
            DestLfoLCD(Lfo1Dest,15,3);
        }
        break;
  }
  // remettre a zero le decalage fine
  // si destination en dehors du range 4,5,6
  if (Lfo1Dest <4 ||Lfo1Dest>6) {
      lfofine1=0;
      lfofine2=0;
      lfofine3=0;
  }
    
}

//-----------------------------------------------
// Gestion encodeur lfo2
// regle forme onde, vitesse, niveau, destination
//-----------------------------------------------
void gestionEncLfo2(void)
{
  switch(valencodeurs) {
      // Wave Down
      case ENC1DOWN:
        if (Lfo2Wave) {
            Lfo2Val=0;
            Lfo2Pos=0;
            ResetLfoDest(Lfo2Dest);
            Lfo2Wave--;
            WaveLfoLCD(Lfo2Wave,0,3);
        }
        break;
      // Wave UP
      case ENC1UP:
        if (Lfo2Wave<6) {
            Lfo2Val=0;
            Lfo2Pos=0;
            ResetLfoDest(Lfo2Dest);
            Lfo2Wave++;
            WaveLfoLCD(Lfo2Wave,0,3);
        }
        break;
      // Rate Down
      case ENC2DOWN:
        if (Lfo2Speed>1) {
            Lfo2Speed--;
            digitsLcd(Lfo2Speed,6,3,3);
            Lfo2Prescaler=255-Lfo2Speed*2;
        }
        break;
      // Rate UP
      case ENC2UP:
        if (Lfo2Speed<127) {
            Lfo2Speed++;
            digitsLcd(Lfo2Speed,6,3,3);
            Lfo2Prescaler=255-Lfo2Speed*2;
        }
        break;
      // Level Down
      case ENC3DOWN:
        if (Lfo2Level>1) {
            Lfo2Level--;
            digitsLcd(Lfo2Level,11,3,3);
        }
        break;
      // Level UP
      case ENC3UP:
        if (Lfo2Level<127) {
            Lfo2Level++;
            digitsLcd(Lfo2Level,11,3,3);
        }
        break;
      // Destination Down
      case ENC4DOWN:
        if (Lfo2Dest>0) {
            Lfo2Val=0;
            Lfo2Pos=0;
            ResetLfoDest(Lfo2Dest);
            Lfo2Dest--;
            DestLfoLCD(Lfo2Dest,15,3);
        }
        break;
      // Destination UP
      case ENC4UP:
        if (Lfo2Dest<8) {
            Lfo2Val=0;
            Lfo2Pos=0;
            ResetLfoDest(Lfo2Dest);
            Lfo2Dest++;
            DestLfoLCD(Lfo2Dest,15,3);
        }
        break;
  }
  if (Lfo2Dest <4 ||Lfo2Dest>6) {
      lfofine1=0;
      lfofine2=0;
      lfofine3=0;
  }
}




//---------------------------
// Gestion principale des LFO
//---------------------------
void gestion_lfos(void) 
{
  
  Lfo1Prescaler=255-Lfo1Speed*2;
  Lfo2Prescaler=255-Lfo2Speed*2;
  // Tester micros() a deja fait le tour du compteur
  if (micros() < LastMicros ) {
    LastMicros=micros();          // Reinitialiser LastMicro
    return;
  }
  // Si le temps dun pas est ecoulé
  if ( micros() > LastMicros+DELAYLFOS ) {
    LastMicros=micros();              // Reinitialiser LastMicro
    // Gestion LFO 1
    Lfo1Counter++;                    // 1 increment toutes les 2 ms
    if (Lfo1Counter>Lfo1Prescaler) {  // Si overflow
        Lfo1Counter=0;                // remettre a zero
        Lfo1Pos++;                    // incrementer position dans forme onde
        if (Lfo1Pos>63)               // si derniere position
            Lfo1Pos=0;                // reprendre au debut
    }   
    // Gestion LFO 2
    Lfo2Counter++;                    // 1 increment toutes les 2 ms
    if (Lfo2Counter>Lfo2Prescaler) {  // Si overflow
        Lfo2Counter=0;                // remettre a zero
        Lfo2Pos++;                    // incrementer position dans forme onde
        if (Lfo2Pos>63)               // si derniere position
            Lfo2Pos=0;                // reprendre au debut
    }
  }
  // Si une forme donde lfo a ete choisie
  // Et qu'une destination a ete selectionnee
  if (Lfo1Wave && Lfo1Dest) {
      switch(Lfo1Wave) {
        case 1:
          Lfo1Val=pgm_read_word(&(LFO_Saw1[Lfo1Pos]));
          break;
        case 2:
          Lfo1Val=pgm_read_word(&(LFO_Saw2[Lfo1Pos]));
          break;
        case 3:
          Lfo1Val=pgm_read_word(&(LFO_Sine[Lfo1Pos]));
          break;
        case 4:
          Lfo1Val=pgm_read_word(&(LFO_Tri1[Lfo1Pos]));
          break;
        case 5:
          Lfo1Val=pgm_read_word(&(LFO_Tri2[Lfo1Pos]));
          break;
        case 6:
          Lfo1Val=pgm_read_word(&(LFO_Square[Lfo1Pos]));
          break;
        default :
          Lfo1Val=0;
          break;
      }
      // Si la valeur LFO a changee
      if (LastLfo1Val!=Lfo1Val) {
        LastLfo1Val=Lfo1Val;
        switch(Lfo1Dest) {
          case 1:
            // Si destination PWM1
            DoHandleControlChange (1,CC_DUTY1,pw1>>4);
            break;
          case 2:
            // Si destination PWM2
            DoHandleControlChange (1,CC_DUTY2,pw2>>4);
            break;
          case 3:
            // Si destination PWM3
            DoHandleControlChange (1,CC_DUTY3,pw3>>4);
            break;
          case 4:
            // Si destination FINE1
            DoHandleControlChange (1,CC_FINE1,fine1);
            break;
          case 5:
            // Si destination FINE2
            DoHandleControlChange (1,CC_FINE2,fine2);
            break;
          case 6:
            // Si destination FINE3
            DoHandleControlChange (1,CC_FINE3,fine3);
            break;
          case 7:
            // Si destination CUT
            DoHandleControlChange (1,CC_CUT,freq>>4);
            break;
          case 8:
            myByte1=res>>4;
            myByte1=myByte1<<3;
            // Si destination CUT
            DoHandleControlChange (1,CC_RES,myByte1);
            break;
        }
      }
  }
  // Si une forme donde lfo a ete choisie
  // Et qu'une destination a ete selectionnee
  if (Lfo2Wave && Lfo2Dest) {
      switch(Lfo2Wave) {
        case 1:
          Lfo2Val=pgm_read_word(&(LFO_Saw1[Lfo2Pos]));
          break;
        case 2:
          Lfo2Val=pgm_read_word(&(LFO_Saw2[Lfo2Pos]));
          break;
        case 3:
          Lfo2Val=pgm_read_word(&(LFO_Sine[Lfo2Pos]));
          break;
        case 4:
          Lfo2Val=pgm_read_word(&(LFO_Tri1[Lfo2Pos]));
          break;
        case 5:
          Lfo2Val=pgm_read_word(&(LFO_Tri2[Lfo2Pos]));
          break;
        case 6:
          Lfo2Val=pgm_read_word(&(LFO_Square[Lfo2Pos]));
          break;
        default :
          Lfo2Val=0;
          break;
      }
      // Si la valeur LFO a changee
      // mettre a jour la destination
      if (LastLfo2Val!=Lfo2Val) {
        LastLfo2Val=Lfo2Val;
        switch(Lfo2Dest) {
          // Si destination PWM1
          case 1:
            DoHandleControlChange (1,CC_DUTY1,pw1>>4);
            break;
          // Si destination PWM2
          case 2:
            DoHandleControlChange (1,CC_DUTY2,pw2>>4);
            break;
          // Si destination PWM3
          case 3:
            DoHandleControlChange (1,CC_DUTY3,pw3>>4);
            break;
          case 4:
            // Si destination FINE1
            DoHandleControlChange (1,CC_FINE1,fine1);
            break;
          case 5:
            // Si destination FINE2
            DoHandleControlChange (1,CC_FINE2,fine2);
            break;
          case 6:
            // Si destination FINE3
            DoHandleControlChange (1,CC_FINE3,fine3);
            break;
          // Si destination CUT
          case 7:
            DoHandleControlChange (1,CC_CUT,freq>>4);
            break;
          // Si destination RES
          case 8:
            myByte1=res>>4;
            myByte1=myByte1<<3;
            // Si destination CUT
            DoHandleControlChange (1,CC_RES,myByte1);
            break;
        }
      }
  }
}


void setup() 
{
  //pinMode(A5,INPUT);
  //delay(1000);
  pinMode(A3,INPUT);
  // Set up the SID chip
  sid.clk_setup();
  sid.SPI_setup();

  // Give the voices some initial values
  // Set up the MIDI input
  MIDI.begin();
  MIDI.setHandleNoteOn(DoHandleNoteOn);
  MIDI.setHandleNoteOff(DoHandleNoteOff);
  MIDI.setHandleControlChange(DoHandleControlChange);

  synth_init();
  
  //---------------------------------------------
  // Modifs F. ABIGNOLI
  //---------------------------------------------
  encodeursSetup();
  lcdSetup(); 
  zicIntro();
  lcd.clear();
  lcd.setCursor(0,1);
  lcd.print(F("RAM Free : "));
  lcd.print(freeMemory(),DEC);
  lcd.print(F(" Oct."));
  delay(2000);
  lcd.clear();
  memset(nomPreset,0,sizeof(nomPreset));
  load_preset(0,0);
  aff_menu_LCD(9);          // initialise menu principal
  Lfo1Prescaler=100;
  Lfo1Pos=0;
  Lfo1Counter=0;
  Lfo2Prescaler=100;
  Lfo2Pos=0;
  Lfo2Counter=0;
  lfofine1=0;
  lfofine2=0;
  lfofine3=0;
  LastMicros=micros();
}



// Main program 
//
void loop() {
  gestion_menu_principal();  
  gestion_lfos();
  //countnote++;
  MIDI.read();
}













